--神陵秘境 累计收益窗口
Lua_JokerAccruedIncomeWindow = class("Lua_JokerAccruedIncomeWindow", Lua_Window);
function Lua_JokerAccruedIncomeWindow:ctor()
	self:superCall("ctor");
	self.showClose = false;
	self.windowName = "Lua_JokerAccruedIncomeWindow";
	self.skinName = "JokerAccruedIncomeWindow_skin";
	self:addPreLoadRes("/effects/uiEffects/gui_leijishouyi", Lua_LoadFileType.UNITY3D);
end

function Lua_JokerAccruedIncomeWindow:buildPanel(go)
	self:superCall("buildPanel", go);
	self:addLuaEvent("CLOSE_JOKER_WINDOW", self, self.hide);--重置时关闭窗口
end

function Lua_JokerAccruedIncomeWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.playEff = UICreate.createModelEffImg(self.content, "/effects/uiEffects/gui_leijishouyi", "gui_leijishouyi", 0, 38, 0, 0);
	
	self.dragContainer = Lua_DragContainer.new(self.content, 600, 280, Lua_AxisDefine.Vertical);
	self.dragContainer:addSubContainer(Lua_JokerAccruedDragItem);
	self.dragContainer:setLocation(0, 140, 0);
end

function Lua_JokerAccruedIncomeWindow:showWin(param)
	self.dragContainer:setChildData(param, true);
	self.dragContainer.canDrag = param:getSize() > 12;
end

function Lua_JokerAccruedIncomeWindow:dispose()
	if self.dragContainer ~= nil then
		self.dragContainer:dispose();
		self.dragContainer = nil;
	end

	if self.playEff ~= nil then
		self.playEff:dispose();
		self.playEff = nil;
	end

	self:superCall("dispose");
end


















Lua_JokerAccruedDragItem = class("Lua_JokerAccruedDragItem", Lua_DragContainerItem);
function Lua_JokerAccruedDragItem:ctor(p)
	self:superCall("ctor", p, "Lua_JokerAccruedDragItem");
end

function Lua_JokerAccruedDragItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_JokerAccruedDragItem:dispose()
	if self.itemArr ~= nil then
		self.itemArr:dispose();
		self.itemArr:clear();
		self.itemArr = nil;
	end
	self:superCall("dispose");
end

function Lua_JokerAccruedDragItem:setData(data)
	local itemPosX = -150;
	local itemPosY = 0;
	local item;
	self.itemArr = Array();
	self.length = data:getSize();
	for i = 1, self.length do
		item = Lua_JokerAccruedIncomeItem.new(self.content);
		item:setData(data[i]);

		if self.length > 1 then
			if i % 2 == 0 then
				item:setLocation(itemPosX + item:getWidth(), itemPosY, 0);
				itemPosY = itemPosY - item:getHeight();
			else
				item:setLocation(itemPosX, itemPosY, 0);
			end
		else
			item:setLocation(0, 0, 0);
		end
		self.itemArr:add(item);
	end
end

function Lua_JokerAccruedDragItem:getWidth()
	return 560;
end

function Lua_JokerAccruedDragItem:getHeight()
	local line = Mathf.Ceil(self.length / 2);
	return 40 * line;
end

























Lua_JokerAccruedIncomeItem = class("Lua_JokerAccruedIncomeItem", Lua_DisplayObject);
function Lua_JokerAccruedIncomeItem:ctor(p)
	self:superCall("ctor", p, "JokerAccruedIncomeItem_skin");
end

function Lua_JokerAccruedIncomeItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_JokerAccruedIncomeItem:dispose()
	self:superCall("dispose");
end

function Lua_JokerAccruedIncomeItem:setData(data)
	self.itemIcon:setAltas(tostring(data.iconAtlas),tostring(data.iconSprite));
	self.itemInfo.text = LanUtil.formateStr(201840, tostring(data.name), tostring(numberTrans(data.count)));
end

function Lua_JokerAccruedIncomeItem:getWidth()
	return 280;
end

function Lua_JokerAccruedIncomeItem:getHeight()
	return 40;
end

