--神陵秘境 属性加成窗口
Lua_JokerAttributeWindow = class("Lua_JokerAttributeWindow", Lua_Window);
function Lua_JokerAttributeWindow:ctor()
	self:superCall("ctor");

	self.h = 300;
	self.w = 400;
	self.showClose = false;
	self.showWinBg = false;
	self.showBlackMask = true;
	self.isClickClose = true;
	self.windowName = "Lua_JokerAttributeWindow";
	self.skinName = "JokerAttributeWindow_skin";
end

function Lua_JokerAttributeWindow:buildPanel(go)
	self:superCall("buildPanel", go);
	
	self:addLuaEvent("UPDATE_JOKER_INFO", self, self.showAttributte);
	self:addLuaEvent("CLOSE_JOKER_WINDOW", self, self.hide);--重置时关闭窗口
end

function Lua_JokerAttributeWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.maskBg.alpha = 0.01;
end

function Lua_JokerAttributeWindow:showWin(param)
	self:superCall("showWin", param);

	self.showPosX = param.posX == nil and 0 or param.posX;
	self.showPosY = param.posY == nil and 0 or param.posY;
	self:updateScreenSize();

	self:showAttributte();
end

function Lua_JokerAttributeWindow:showAttributte()
	local list = DataCenter.jokerDuelData.attributeArr;

	if list ~= nil then
		local isLeft = true;
		local showLeft = "";
		local showRight = "";

		local listLen = list:getSize();
		self.tips:setEnable(listLen <= 0);
		self:updateShowSize(listLen);

		for i = 1, list:getSize() do
			local showName = tostring(list[i].show_name);
			if string.len(showName) <= 6 then
				showName = showName .. LanUtil.getValue(201845);
			end

			local showStr = LanUtil.formateStr(201839, tostring(showName), tostring(list[i].showValue));
			if isLeft then
				showLeft = showLeft .. showStr;
			else
				showRight = showRight .. showStr;
			end
			isLeft = not isLeft;
		end
		self.leftTxt.text = showLeft;
		self.rightTxt.text = showRight;
	end
end

function Lua_JokerAttributeWindow:updateShowSize(len)
	local differ = len - 8;
	if differ > 0 then
		local time = Mathf.Ceil(differ / 2);
		self.winBg:SetDimensions(400, 190 + time * 27);
		self.titleName:setLocation(0, -58 - time * 27, 0);
	end
end

function Lua_JokerAttributeWindow:onScreenResize()
	self:superCall("onScreenResize");
	self:updateScreenSize();
end

function Lua_JokerAttributeWindow:updateScreenSize()
	if self.showPosY >= 0 then
		LuaUtil.setObjPos(self.gameObject, self.showPosX, self.showPosY + self.adaptHeight / 2, 0);
	else
		LuaUtil.setObjPos(self.gameObject, self.showPosX, self.showPosY - self.adaptHeight / 2, 0);
	end
end

function Lua_JokerAttributeWindow:dispose()
	self.showPosX = nil;
	self.showPosY = nil;
	self:superCall("dispose");
end