--神陵秘境 主持问答窗口
Lua_JokerDeulAnswerWindow = class("Lua_JokerDeulAnswerWindow", Lua_Window);

function Lua_JokerDeulAnswerWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_JokerDeulAnswerWindow";
	self.skinName = "JokerDeulAnswerWindow_skin";
end

function Lua_JokerDeulAnswerWindow:buildPanel(go)
	self:superCall("buildPanel", go);
	
	self:addLuaEvent("UPDATE_JOKER_CELLCLIEK", self, self.updateInfo);--点击格子
	self:addLuaEvent("UPDATE_JOKER_ANSWER", self, self.showResult);--回答问题
	self:addLuaEvent("CLOSE_JOKER_WINDOW", self, self.hide);--重置时关闭窗口

	self:addLuaEvent("JOKER_ANSWAER_SELECT", self, self.updateSelect);--选择答案
end

function Lua_JokerDeulAnswerWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.endTime = DataCenter.jokerDuelUtil:getConstVo("answer_cut_time").float_value;

	local itemPos = {{-100, -100}, {150, -100}, {-100, -200}, {150, -200}};
	self.itemArr = Array();
	for i = 1, #itemPos do
		local item = Lua_JokerDeulAnswerItem.new(self.content, i);
		item:setLocation(itemPos[i][1], itemPos[i][2], 0);
		self.itemArr:add(item);
	end

	self.rewardItem = Lua_ItemIconList.new(self.content)
	self.rewardItem:setLocation(0, -380, 0);
end

function Lua_JokerDeulAnswerWindow:showWin(param)
	self.cellIndex = param;
	self:updateInfo();
end

function Lua_JokerDeulAnswerWindow:updateInfo()
	local data = DataCenter.jokerEventData;
	local vo = DataCenter.jokerDuelUtil:getEventVo(data.curQuestionId);

	self.isSelect = false;

	local showTitle = data.curTitle <= data.totalTitle and data.curTitle or data.totalTitle;
	self.questionRankTxt.text = LanUtil.formateStr(201833, tostring(showTitle), tostring(data.totalTitle));
	self.questionTxt.text = vo.qa_title;

	for i = 1, self.itemArr:getSize() do--答题选项
		self.itemArr[i]:setData(vo.qa_choose[i]);
	end

	if data.totalRewardArr:getSize() > 0 then--全部奖励
		self.rewardItem:setArrayData(data.totalRewardArr);
	end

	if data.curTitle <= data.totalTitle then--未答满题目
		self:showCurReward();
	else
		self:showEndReward();
		self:hide();
	end
end

function Lua_JokerDeulAnswerWindow:showCurReward()--累计奖励
	local curReward = DataCenter.jokerEventData.curRewardArr;
	if curReward:getSize() > 0 then
		self.rewardItem1:setAltas(tostring(curReward[1].iconAtlas), tostring(curReward[1].iconSprite));
		self.rewardItem2:setAltas(tostring(curReward[2].iconAtlas), tostring(curReward[2].iconSprite));
		self.rewardTxt1.text = curReward[1].count;
		self.rewardTxt2.text = curReward[2].count;
	end
end

function Lua_JokerDeulAnswerWindow:updateSelect(index)
	if not self.isSelect then
		self.isSelect = true;

		local vo = DataCenter.jokerDuelUtil:getEventVo(DataCenter.jokerEventData.curQuestionId);
		if vo.qa_answer == index then--选项正确
			self.itemArr[index]:showSelect(true, true);
		else
			self.itemArr[vo.qa_answer]:showSelect(true, false);
			self.itemArr[index]:showSelect(false, true);
		end
		Lua_ProxyManager.getProxy("Lua_JokerDuelProxy"):sJokerAnswerQuestion(index, self.cellIndex);
	end
end

function Lua_JokerDeulAnswerWindow:showResult()
	self:showCurReward();
	
	if not self.isShow then
		self.isShow = true;
		Lua_CommonUtil.delayCall(self.endTime, self, self.onShowResult);
	end
end

function Lua_JokerDeulAnswerWindow:onShowResult()
	if self.isShow then
		self.isShow = false;
		Lua_CommonUtil.removeTimer(self, self.onShowResult);
		self:updateInfo();
	end
end

function Lua_JokerDeulAnswerWindow:showEndReward()
	if not self.isFistShow then
		self.isFistShow = true;

		local curReward = DataCenter.jokerEventData.curRewardArr;
		if curReward[1].count > 0 then
			local tips1 = LanUtil.formateStr(201826, tostring(curReward[1].colorName), tostring(curReward[1].count));
			local tips2 = LanUtil.formateStr(201842, tostring(curReward[2].colorName), tostring(curReward[2].count));
			local showTip = tips1 .. "  " .. tips2;
			OperateAlert.show(showTip);
		end
		local tip = DataCenter.jokerDuelUtil:getConstVo("answer_reward_tip").json_value[tonumber(DataCenter.jokerEventData.curRightNum + 1)];
		OperateAlert.show(tip);
	end
end

function Lua_JokerDeulAnswerWindow:dispose()
	if self.itemArr ~= nil then
		self.itemArr:dispose();
		self.itemArr:clear();
		self.itemArr = nil;
	end
	if self.rewardItem ~= nil then
		self.rewardItem:dispose();
		self.rewardItem = nil;
	end

	if DataCenter.jokerEventData.curTitle > DataCenter.jokerEventData.totalTitle then
		self:showEndReward();
	end

	Lua_CommonUtil.removeTimer(self, self.onShowResult);
	self:superCall("dispose");
end

































Lua_JokerDeulAnswerItem = class("Lua_JokerDeulAnswerItem", Lua_DisplayObject);
function Lua_JokerDeulAnswerItem:ctor(p, index)
	self.index = index;
	self:superCall("ctor", p, "JokerDeulAnswerItem_skin");
end

function Lua_JokerDeulAnswerItem:buildShowItem()
	self:superCall("buildShowItem");

	self.optionTxt.text = DataCenter.jokerDuelUtil:getConstVo("answer_option_tip").json_value[tonumber(self.index)];
	self.selectBg:addClickFuntion(self, self.onSelectBgClick);
end

function Lua_JokerDeulAnswerItem:setData(data)
	self.answerTxt.text = data;

	self.selectSign:setEnable(false);
	self.selectBg:setAltas("jokerDuel_altas", "Trumpgame_widget_06");
end

function Lua_JokerDeulAnswerItem:onSelectBgClick()
	Lua_MsgUtil.callFunc("JOKER_ANSWAER_SELECT", self.index);
end

function Lua_JokerDeulAnswerItem:showSelect(isTrue, isCurSelect)
	if isTrue then
		self.selectSign:setAltas("jokerDuel_altas", "Trumpgame_widget_02");
		if isCurSelect then
			self.selectBg:setAltas("jokerDuel_altas", "Trumpgame_widget_04");
		end
	else
		self.selectSign:setAltas("jokerDuel_altas", "Trumpgame_widget_03");
		if isCurSelect then
			self.selectBg:setAltas("jokerDuel_altas", "Trumpgame_widget_05");
		end
	end
	self.selectSign:setEnable(true);
end

function Lua_JokerDeulAnswerItem:dispose()
	self:superCall("dispose");
end