--神陵秘境 猜拳互动窗口
Lua_JokerDeulGuessWindow = class("Lua_JokerDeulGuessWindow", Lua_Window);

function Lua_JokerDeulGuessWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_JokerDeulGuessWindow";
	self.skinName = "JokerDeulGuessWindow_skin";
end

function Lua_JokerDeulGuessWindow:buildPanel(go)
	self:superCall("buildPanel", go);
	self:addLuaEvent("UPDATE_JOKER_GUESS_COST", self, self.updateCostEvent);--下注选择
	self:addLuaEvent("UPDATE_JOKER_GUESS_FIST", self, self.updateFistEvent);--出招选择
	self:addLuaEvent("CLOSE_JOKER_WINDOW", self, self.hide);--重置时关闭窗口
end

function Lua_JokerDeulGuessWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.isShowReward = false;

	self.costItemPos = {{-220, -100}, {-70, -100}, {80, -100}, {230, -100}};
	self.costItemArr = Array();
	for i = 1, #self.costItemPos do
		local item = Lua_JokerGuessCostItem.new(self.content, i);
		item:setLocation(self.costItemPos[i][1], self.costItemPos[i][2], 0);
		self.costItemArr:add(item);
	end
	self.title1:setLangValue(201847);
	self.tip:setLangValue(201848);
end

function Lua_JokerDeulGuessWindow:showWin(param)
	self.cellIndex = param;

	self.fistItemPos = {{-185, -330}, {15, -330}, {215, -330}};
	self.fistItemArr = Array();
	for i = 1, #self.fistItemPos do
		local item = Lua_JokerGuessFistItem.new(self.content, i, self.cellIndex);
		item:setLocation(self.fistItemPos[i][1], self.fistItemPos[i][2], 0);
		self.fistItemArr:add(item);
	end
end

function Lua_JokerDeulGuessWindow:updateCostEvent()
	if self.selectCost ~= DataCenter.jokerEventData.guessCostSelect then
		self.selectCost = DataCenter.jokerEventData.guessCostSelect;

		self.selectObj:SetActive(false);
		self.selectTxt:setLangValue(201832);
		Lua_CommonUtil.removeTimer(self, self.updateSelectSign);
		Lua_CommonUtil.delayCall(0.5, self, self.updateSelectSign);
	end
end

function Lua_JokerDeulGuessWindow:updateSelectSign()
	Lua_CommonUtil.removeTimer(self, self.updateSelectSign);
	LuaUtil.setObjPos(self.selectObj, 10, 10, 0);
	self.selectObj:SetActive(true);
end

function Lua_JokerDeulGuessWindow:updateFistEvent()
	if not self.isGuess then
		self.isGuess = true;

		self.selectObj:SetActive(false);
		self.guessObj:SetActive(true);
		self.myRiot:setAltas("jokerDuel_altas", "Trumpgame_widget_0" .. 7 +  DataCenter.jokerEventData.guessFistSelect);
		self.btnClose:removeClickFuntion(self, self.onBtnCloseClick);

		self.cutMyIndex = 1;--我方出招
		self.cutPeerIndex = 2;--对方出招
		self.onTimer = 0;--猜拳进行时间
		self.intervalTime = 0.1;--猜拳切换间隔
		self.endTime = DataCenter.jokerDuelUtil:getConstVo("guess_time").float_value;--猜拳结束时间
		Lua_CommonUtil.addTimer("onCountDown", self.intervalTime, self, self.onCountDown);
	end
end

function Lua_JokerDeulGuessWindow:onCountDown()
	self.onTimer = self.onTimer + self.intervalTime;
	if self.onTimer < self.endTime then
		self.cutMyIndex = self.cutMyIndex + 1;
		self.cutPeerIndex = self.cutPeerIndex + 1;
		if self.cutMyIndex > 3 then
			self.cutMyIndex = 1;
		end
		if self.cutPeerIndex > 3 then
			self.cutPeerIndex = 1;
		end

		if self.cutMyIndex <= 2 then
			self.myRiot:setAltas("jokerDuel_altas", "Trumpgame_widget_0" .. 7 + self.cutMyIndex);
		else
			self.myRiot:setAltas("jokerDuel_altas", "Trumpgame_widget_10");
		end
		self.peerRiot:setAltas("jokerDuel_altas", "Trumpgame_widget_1" .. self.cutPeerIndex);
	else
		self:showResult();
	end
end

function Lua_JokerDeulGuessWindow:showResult()
	Lua_CommonUtil.removeTimer(self, self.onCountDown);

	if DataCenter.jokerEventData.playerType > 1 then
		self.myRiot:setAltas("jokerDuel_altas", "Trumpgame_widget_0" .. 11 -  DataCenter.jokerEventData.playerType);
	else
		self.myRiot:setAltas("jokerDuel_altas", "Trumpgame_widget_10");
	end
	self.peerRiot:setAltas("jokerDuel_altas", "Trumpgame_widget_1" .. 4 - DataCenter.jokerEventData.pcType);

	if DataCenter.jokerEventData.guessResult == 1 then
		local vo =  DataCenter.jokerDuelUtil:getEventVo(1000);
		local selectIndex = tonumber(DataCenter.jokerEventData.guessCostSelect);
		local betType = vo.betType[selectIndex];
		OperateAlert.show(LanUtil.formateStr(201829, tostring(betType.name)));
	elseif DataCenter.jokerEventData.guessResult == 2 then
		OperateAlert.showLangValue(201831);
	else
		OperateAlert.showLangValue(201830);
	end

	self.btnClose:addClickFuntion(self, self.onBtnCloseClick);
	Lua_CommonUtil.delayCall(2, self, self.closeGuessWin);
end

function Lua_JokerDeulGuessWindow:closeGuessWin()
	Lua_CommonUtil.removeTimer(self, self.closeGuessWin);

	self.isShowReward = true;
	local reward = DataCenter.jokerEventData.guessReward;
	OperateAlert.show(LanUtil.formateStr(201826, tostring(reward.colorName), tostring(reward.count)));
	self:hide();
end

function Lua_JokerDeulGuessWindow:dispose()
	if self.costItemArr ~= nil then
		self.costItemArr:dispose();
		self.costItemArr:clear();
		self.costItemArr = nil;
	end
	if self.fistItemArr ~= nil then
		self.fistItemArr:dispose();
		self.fistItemArr:clear();
		self.fistItemArr = nil;
	end

	if DataCenter.jokerEventData.guessFistSelect ~= nil and self.isShowReward == false then
		local reward = DataCenter.jokerEventData.guessReward;
		if reward ~= nil then
			OperateAlert.show(LanUtil.formateStr(201826, tostring(reward.colorName), tostring(reward.count)));
		end
	end

	Lua_CommonUtil.removeTimer(self, self.updateSelectSign);
	Lua_CommonUtil.removeTimer(self, self.onCountDown);
	Lua_CommonUtil.removeTimer(self, self.closeGuessWin);
	self:superCall("dispose");
end


















Lua_JokerGuessCostItem = class("Lua_JokerGuessCostItem", Lua_DisplayObject);
function Lua_JokerGuessCostItem:ctor(p, index)
	self.index = index;
	self:superCall("ctor", p, "JokerGuessCostItem_skin");
end

function Lua_JokerGuessCostItem:buildShowItem()
	self:superCall("buildShowItem");

	local betVo =  DataCenter.jokerDuelUtil:getEventVo(1000).betType[self.index];
	self.costTxt.text = betVo.count;
	self.itemSp:setAltas("jokerDuel_altas", "Trumpgame_widget_" .. 16 + self.index);
	self.itemSp:resetSize();

	self.itemSp:addClickFuntion(self, self.onCostBtnClick);
	self.costBg:addClickFuntion(self, self.onCostBtnClick);

	self:addLuaEvent("UPDATE_JOKER_GUESS_COST", self, self.updateSelect);
end

function Lua_JokerGuessCostItem:updateSelect()
	if self.index == DataCenter.jokerEventData.guessCostSelect then
		self.selectBg:setEnable(true);
		self.costBg:setAltas("jokerDuel_altas", "Trumpgame_widget_15");
	else
		if self.isPlay then
			self:removePlayEff();
		end

		self.selectBg:setEnable(false);
		self.costBg:setAltas("jokerDuel_altas", "Trumpgame_widget_14");
	end
	self.costBg:resetSize();
end

function Lua_JokerGuessCostItem:onCostBtnClick()
	if DataCenter.jokerEventData.guessFistSelect == nil then
		local betVo =  DataCenter.jokerDuelUtil:getEventVo(1000).betType[self.index];
		if DataCenter.moneyData:isMoneyEnough(betVo.id, betVo.count, true, true, false) then
			if self.index ~= DataCenter.jokerEventData.guessCostSelect then
				self:startPlayEff();
			end

			DataCenter.jokerEventData.guessCostSelect = self.index;
			Lua_ProxyManager.getProxy("Lua_JokerDuelProxy"):sJokerGuessCostType(self.index);
			Lua_MsgUtil.callFunc("UPDATE_JOKER_GUESS_COST");
		end
	end
end

function Lua_JokerGuessCostItem:startPlayEff()
	if not self.isPlay then
		self.isPlay = true;

		self.timer = 0;
		self.cutTime = 0.2;
		self.playTime = 1;

		self.clickBg1:setEnable(true);
		Lua_CommonUtil.addTimer("onPlayEff", self.cutTime, self, self.onPlayEff);
	end
end

function Lua_JokerGuessCostItem:onPlayEff()
	self.timer = self.timer + self.cutTime;
	if self.timer == self.cutTime then
		self.clickBg2:setEnable(true);
	elseif self.timer >= self.playTime then
		self:removePlayEff();
	end
end

function Lua_JokerGuessCostItem:removePlayEff()
	Lua_CommonUtil.removeTimer(self, self.onPlayEff);
	self.isPlay = false;

	self.clickBg1:setEnable(false);
	self.clickBg2:setEnable(false);
end

function Lua_JokerGuessCostItem:dispose()
	Lua_CommonUtil.removeTimer(self, self.onPlayEff);
	self:superCall("dispose");
end






























Lua_JokerGuessFistItem = class("Lua_JokerGuessFistItem", Lua_DisplayObject);

function Lua_JokerGuessFistItem:ctor(p, index, cellIndex)
	self.index = index;
	self.cellIndex = cellIndex;
	self:superCall("ctor", p, "JokerGuessFistItem_skin");
end

function Lua_JokerGuessFistItem:buildShowItem()
	self:superCall("buildShowItem");

	if self.index ~= 3 then
		self.fistItem:setAltas("jokerDuel_altas", "Trumpgame_widget_0" .. 7 + self.index);
	else
		self.fistItem:setAltas("jokerDuel_altas", "Trumpgame_widget_10");
	end
	self.selectBg:addClickFuntion(self, self.onShowItemClick);

	self:addLuaEvent("UPDATE_JOKER_GUESS_FIST", self, self.updateSelect);
end

function Lua_JokerGuessFistItem:updateSelect()
	if self.index == DataCenter.jokerEventData.guessFistSelect then
		self.selectBg:setAltas("jokerDuel_altas", "Trumpgame_widget_22");
	else
		self.selectBg:setAltas("jokerDuel_altas", "Trumpgame_widget_21");
	end
	self.selectBg:resetSize();
end

function Lua_JokerGuessFistItem:onShowItemClick()
	if DataCenter.jokerEventData.guessCostSelect == nil  then
		OperateAlert.showLangValue(201827);
		return;
	end

	if DataCenter.jokerEventData.guessFistSelect == nil then
		local betVo = DataCenter.jokerDuelUtil:getEventVo(1000).betType[DataCenter.jokerEventData.guessCostSelect];
		if DataCenter.moneyData:isMoneyEnough(betVo.id, betVo.count, true, true, false) then
			DataCenter.jokerEventData.guessFistSelect = self.index;
			OperateAlert.show(LanUtil.formateStr(201828, tostring(betVo.name), tostring(betVo.count)));

			local selectIndex = 4 - self.index;
			Lua_ProxyManager.getProxy("Lua_JokerDuelProxy"):sJokerGuessFist(selectIndex, self.cellIndex);
			Lua_MsgUtil.callFunc("UPDATE_JOKER_GUESS_FIST");

			self:startPlayEff();
		end
	end
end

function Lua_JokerGuessFistItem:startPlayEff()
	if not self.isPlay then
		self.isPlay = true;

		self.timer = 0;
		self.cutTime = 0.2;
		self.playTime = 1;

		self.clickBg1:setEnable(true);
		Lua_CommonUtil.addTimer("onPlayEff", self.cutTime, self, self.onPlayEff);
	end
end

function Lua_JokerGuessFistItem:onPlayEff()
	self.timer = self.timer + self.cutTime;
	if self.timer == self.cutTime then
		self.clickBg2:setEnable(true);
	end
	if self.timer >= self.playTime then
		Lua_CommonUtil.removeTimer(self, self.onPlayEff);
		self.clickObj:SetActive(false);
	end
end

function Lua_JokerGuessFistItem:dispose()
	Lua_CommonUtil.removeTimer(self, self.onPlayEff);
	self:superCall("dispose");
end
