--神陵秘境 保险柜窗口
Lua_JokerDeulSafeWindow = class("Lua_JokerDeulSafeWindow", Lua_Window);

function Lua_JokerDeulSafeWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_JokerDeulSafeWindow";
	self.skinName = "JokerDeulSafeWindow_skin";
end

function Lua_JokerDeulSafeWindow:buildPanel(go)
	self:superCall("buildPanel", go);
	
	self:addLuaEvent("UPDATE_JOKER_CELLCLIEK", self, self.updataInfo);
	self:addLuaEvent("UPDATE_JOKEREVENT_SAFEOPEN", self, self.updataResult);
	self:addLuaEvent("CLOSE_JOKER_WINDOW", self, self.hide);--重置时关闭窗口
end

function Lua_JokerDeulSafeWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.tip3:setLangValue(201849);
	self.config = DataCenter.jokerDuelUtil:getEventVo(3000);

	self.itemList = Lua_ItemIconList.new(self.content);
	self.itemList:setLocation(0, -40, 0);

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setScale(0.8, 0.8, 0.8);
	self.itemIcon:setLocation(0, -240, 0);

	self.boxEff = UICreate.createModelEffImg(self.content, "/effects/uiEffects/gui_baoxiangui_1", "gui_baoxiangui_1", 0, 180, 0, 0);
	self.openBtn:addClickFuntion(self, self.onOpenBtn);
end

function Lua_JokerDeulSafeWindow:showWin(param)
	self.cellIndex = param;
	self:updataInfo();
end

function Lua_JokerDeulSafeWindow:updataInfo()
	local data = DataCenter.jokerEventData;
	self.itemList:setArrayData(self.config.box_reward);

	self.itemIcon:setData(data.boxKey);
	self.itemIcon:showNumLimit(1, data.boxKey.count, 1);

	self.openBtn:setGray(data.boxKey.count < 1);
end

function Lua_JokerDeulSafeWindow:updataResult()
	self:updataInfo();

	if not self.isClose then
		self.isClose = true;
		Lua_CommonUtil.addTimer("onCloseWin", 1, self, self.onCloseWin);
	end
end

function Lua_JokerDeulSafeWindow:onCloseWin()
	if self.isClose then
		self.isClose = false;
		Lua_CommonUtil.removeTimer(self, self.onCloseWin);
		
		self:showTip();
		self:hide();
	end
end

function Lua_JokerDeulSafeWindow:showTip()
	local rewardArr = DataCenter.jokerEventData.boxRewardArr;
	if rewardArr[1] ~= nil then
		OperateAlert.show(LanUtil.formateStr(201826, tostring(rewardArr[1].colorName), tostring(rewardArr[1].count)));
	end
end

function Lua_JokerDeulSafeWindow:onOpenBtn()
	if not self.isOpened then
		self.isOpened = true;

		if DataCenter.jokerEventData.boxKey.count >= 1 then
			self.boxEff:setUrl("/effects/uiEffects/gui_baoxiangui_2", "gui_baoxiangui_2");
			Lua_ProxyManager.getProxy("Lua_JokerDuelProxy"):sJokerOpenSafe(self.cellIndex);
		else
			OperateAlert.showLangValue(201804);
		end
	end
end

function Lua_JokerDeulSafeWindow:dispose()
	if self.itemList ~= nil then
		self.itemList:dispose();
		self.itemList = nil;
	end
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	if self.boxEff ~= nil then
		self.boxEff:dispose();
		self.boxEff = nil;
	end

	if self.isClose then
		self:showTip();
	end
	
	Lua_CommonUtil.removeTimer(self, self.onCloseWin);
	self:superCall("dispose");
end