--神陵秘境 王牌商店窗口
Lua_JokerDeulShopWindow = class("Lua_JokerDeulShopWindow", Lua_Window);

function Lua_JokerDeulShopWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_JokerDeulShopWindow";
	self.skinName = "JokerDeulShopWindow_skin";
end

function Lua_JokerDeulShopWindow:buildPanel(go)
	self:superCall("buildPanel", go);
	
	self:addLuaEvent("UPDATE_JOKER_SHOP", self, self.updateInfo);--更新王牌商店的信息
	self:addLuaEvent("CLOSE_JOKER_WINDOW", self, self.hide);--重置时关闭窗口
end

function Lua_JokerDeulShopWindow:buildShowItem()
	self:superCall("buildShowItem");

	Lua_ProxyManager.getProxy("Lua_JokerDuelProxy"):sJokerOpenShopInfo();

	self.itemList = Lua_DragList.new(self.content, 608, 580, Lua_AxisDefine.Vertical);
	self.itemList:setListCell(Lua_JokerDuelShopItem, 305, 124, 2);
	self.itemList:setCellSpacing(0, 10);
	self.itemList:setLocation(0, 0, 0);
end

function Lua_JokerDeulShopWindow:updateInfo()
	local arr = DataCenter.jokerDuelData.aceShopItemArr;

	self.tipObj:SetActive(arr:getSize() <= 0);
	self.itemList:setArrayData(arr);

	-- self:setCountDown();
end

function Lua_JokerDeulShopWindow:setCountDown()
	self.timer = tonumber(DataCenter.jokerDuelData.resetTick - DataCenter.roleData.serverTime);--关卡倒计时
	if not self.onTimer and self.timer > 0 then
		self.onTimer = true;
		Lua_CommonUtil.addTimer("onCountDown", 1, self, self.onCountDown);

		self.label_time.text = LanUtil.formateStr(201812, tostring(Lua_TimeTransform.transSeconds6(self.timer, true, true)));
	else
		self:hide();
	end
end

function Lua_JokerDeulShopWindow:onCountDown()
	self.timer = self.timer - 1;
	if self.onTimer and self.timer <= 0 then
		self.onTimer = false;
		Lua_CommonUtil.removeTimer(self, self.onCountDown);

		self:hide();
	else
		self.label_time.text = LanUtil.formateStr(201812, tostring(Lua_TimeTransform.transSeconds6(self.timer, true, true)));
	end
end

function Lua_JokerDeulShopWindow:dispose()
	if self.itemList ~= nil then
		self.itemList:dispose();
		self.itemList = nil;
	end

	Lua_CommonUtil.removeTimer(self, self.onCountDown);
	self:superCall("dispose");
end



























Lua_JokerDuelShopItem = class("Lua_JokerDuelShopItem", Lua_ListCell);
function Lua_JokerDuelShopItem:ctor(p)
	self:superCall("ctor", p, "JokerDuelShopItem_skin");
end

function Lua_JokerDuelShopItem:buildShowItem()
	self:superCall("buildShowItem");

	self.shopItem = Lua_ItemIcon.new(self.content);
    self.shopItem:setLocation(-85, 0, 0);
    self.shopItem:setCanClick(false);
end

function Lua_JokerDuelShopItem:setData(data)
	self.data = data;

	self.shopItem:setData(data.itemVo);
	self.label_name.text = data.itemVo.colorName;
	self.label_num.text = numberTrans(data.costNum);
	self.costItem:setAltas(data.costVo.iconAtlas, data.costVo.iconSprite);
	self.costItem:resetSize();
	if data.costVo.id == Lua_ResourcesData.DIAMOND then
		self.costItem:setScale(1, 1, 1);
	else
		self.costItem:setScale(0.5, 0.5, 0.5);
	end

	self.label_discount.text = tostring(data.discount);
	self.discountObj:SetActive(data.showDiscount == 1);
	self.sellOutObj:SetActive(data.amount <= 0);

	self.buyCost = data.amount * data.costNum;
end

function Lua_JokerDuelShopItem:checkOutBound(showRect)
	local rect = Lua_Rectangle.new(self.itemX, self.itemY - 40, 10, 80);
	if showRect:containeRect(rect) == true then
		self.shopItem:showEffect(true);
	else
		self.shopItem:showEffect(false);
	end
end

function Lua_JokerDuelShopItem:onPressClick()
	if self.data.amount > 0  then
		local itemVo = self.data.itemVo;
		if itemVo.count > 0 then
		    local costNum = tostring(numberTrans(self.buyCost));
			local itemName = itemVo.name;
			local itemNum = tostring(numberTrans(itemVo.count));
			local str = spliceIconStr(itemVo.iconAtlas, itemVo.iconSprite, itemVo.iconWidth, itemVo.iconHeight);
		    local tipData = {
		    	des = LanUtil.getValue(201822)..str..LanUtil.formateStr(201823, costNum, itemName, itemNum),
		    	posY = 34, btnType = 1, owner = self, sureFun = self.rSureCostClick
		    };
			Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN ,tipData);
		end
	else
		OperateAlert.showLangValue(130010);
	end
end

function Lua_JokerDuelShopItem:rSureCostClick()
	if DataCenter.moneyData:isMoneyEnough(self.data.costVo.id, self.buyCost, true, true, false) then
		Lua_ProxyManager.getProxy("Lua_JokerDuelProxy"):sJokerBuyShopItem(self.data.index, self.data.amount);
	end
end

function Lua_JokerDuelShopItem:dispose()
	if self.shopItem ~= nil then
		self.shopItem:dispose();
		self.shopItem = nil;
	end
	self:superCall("dispose");
end