--神陵秘境 通行证使用窗口
checkRequire("Lua_JokerDuelMosterItem");
Lua_JokerDuelPassWindow = class("Lua_JokerDuelPassWindow", Lua_Window);

function Lua_JokerDuelPassWindow:ctor()
	self:superCall("ctor");

	self.showClose = false;
	self.windowName = "Lua_JokerDuelPassWindow";
	self.skinName = "JokerDuelPassWindow_skin";
end

function Lua_JokerDuelPassWindow:buildPanel(go)
	self:superCall("buildPanel", go);
	
	self:addLuaEvent("UPDATE_JOKER_ITEMINFO", self, self.updateInfo);
	self:addLuaEvent("UPDATE_JOKER_MONSTERINFO", self, self.updateInfo);
	self:addLuaEvent("CLOSE_JOKER_WINDOW", self, self.hide);--重置时关闭窗口
end

function Lua_JokerDuelPassWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.starList = Lua_DragList.new(self.content, 425, 142, Lua_AxisDefine.Horizontal);
	self.starList:setListCell(Lua_JokerDuelMosterItem, 106, 132, 1);
	self.starList.canDrag = false;
	
	self.cancelBtn:addClickFuntion(self, self.onCancelBtnClick);
	self.sureBtn:addClickFuntion(self, self.onSureBtnClick);
	self.buyBtn:addClickFuntion(self, self.onBuyBtnClick);
end

function Lua_JokerDuelPassWindow:showWin(param)
	self.index = param;
	self:updateInfo();
end

function Lua_JokerDuelPassWindow:updateInfo()
	DataCenter.jokerDuelData:setMonsterIndex();

	local monsterArr = DataCenter.jokerDuelData.getMonsterArr;
	self.starList:setArrayData(monsterArr);
	self.starList:setLocation(53 * (4 - monsterArr:getSize()), -35, 0);

	local isNotExist = monsterArr:getSize() <= 0;
	self.label_tip1:setEnable(isNotExist);

	local data = DataCenter.jokerDuelData.itemInfo[self.index];
	self.itemSp:setAltas(data.itemVo.iconAtlas, data.itemVo.iconSprite);
	self.label_name.text = data.itemVo.name;
	self.label_desc.text = data.itemVo.des;
	self.label_limit.text = LanUtil.formateStr(201820, tostring(data.limitTime));
	self.label_count.text = LanUtil.formateStr(201821, tostring(data.count));
end

function Lua_JokerDuelPassWindow:onCancelBtnClick()
	self:hide();
end

function Lua_JokerDuelPassWindow:onSureBtnClick()
	if DataCenter.jokerDuelData.monsterIndex == nil then
		OperateAlert.showLangValue(201844);
		return;
	end

	local data = DataCenter.jokerDuelData.itemInfo[self.index];
	if data.limitTime <= 0 then
		OperateAlert.showLangValue(201818);
	elseif data.count >= 1 then
		Lua_ProxyManager.getProxy("Lua_JokerDuelProxy"):sJokerUsePass(DataCenter.jokerDuelData.monsterIndex);

		OperateAlert.show(LanUtil.formateStr(201816, tostring(data.itemVo.colorName)));

		if DataCenter.jokerDuelData.getCurMonsterVo.isLeader == 1 then
			OperateAlert.showLangValue(201814);
		else
			OperateAlert.showLangValue(201813);
		end
		self:hide();
	else
		OperateAlert.showLangValue(201804);
	end
end

function Lua_JokerDuelPassWindow:onBuyBtnClick()
	local data = DataCenter.jokerDuelData.itemInfo[self.index];
	local costVo = DataCenter.jokerDuelUtil:getConstVo("buy_permit_diamond_cost").json_value;

	if data.buyTime > 0 then
		local buyData = {};
		buyData.itemVo = data.itemVo;
		buyData.moneyType = costVo[1];
		buyData.moneyCount = costVo[2];
		buyData.leftTimes = data.buyTime;
		buyData.buyType = 2;
		Lua_WindowUtil.openWin("Lua_JokerBuyGoodsWindow", Lua_WinParam.ACTION_OPEN, buyData);
	else
		OperateAlert.showLangValue(201841);
	end
end

function Lua_JokerDuelPassWindow:dispose()
	if self.starList ~= nil then
		self.starList:dispose();
		self.starList = nil;
	end
	self:superCall("dispose");
end
