--神陵秘境 挑战窗口
checkRequire("Lua_JokerDuelStarItem");
Lua_JokerDuelPickWindow = class("Lua_JokerDuelPickWindow", Lua_Window);
function Lua_JokerDuelPickWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_JokerDuelPickWindow";
	self.skinName = "JokerDuelPickWindow_skin";
end

function Lua_JokerDuelPickWindow:buildPanel(go)
	self:superCall("buildPanel", go);
	
	self:addLuaEvent("UPDATE_JOKERDUEL_STARSELECT", self, self.updataSelect);
	self:addLuaEvent("CLOSE_JOKER_WINDOW", self, self.hide);--重置时关闭窗口
end

function Lua_JokerDuelPickWindow:buildShowItem()
	self:superCall("buildShowItem");

	local data = DataCenter.jokerDuelData;

	self.playerIcon = Lua_ItemIcon.new(self.playerObj);
	self.playerIcon:setCanClick(false);
	self.playerIcon:setLocation(-142 , 240, 0);
	self.playerIcon:setData(data.getCurStarVo);

	self.playerHpBar:setMaxValue(data.getCurStarVo.max_blood);
	self.playerHpBar:setValue(data.getCurStarVo.blood);
	self.playerAnagerBar:setMaxValue(100);
	self.playerAnagerBar:setValue(data.getCurStarVo.curEnergy);

	self.starList = Lua_DragList.new(self.content, 600, 145, Lua_AxisDefine.Vertical);
	self.starList:setListCell(Lua_JokerDuelStarItem, 120, 145, 5);
	self.starList.canDrag = false;
	self.starList:setLocation(0 , -38, 0);
	self.starList:setArrayData(data.campArr);

	self.passCheck:setTextField(false);
	self.passCheck:addBoxChange(self, self.onPassCheckChange);
	self.passCheck.selected = data.skipDuel == 1;

	self.duelBtn:addClickFuntion(self, self.onDuleBtnClick);
	self:updataSelect();
end

function Lua_JokerDuelPickWindow:showWin(param)
	self:superCall("showWin", param);

	local index = tonumber(param);

	if index == 13 then
		DataCenter.jokerDuelData.duelLeader = true;
		self.titleName:setAltas("titleName", "fonts_2_237");
	else
		DataCenter.jokerDuelData.duelLeader = false;
		self.titleName:setAltas("titleName", "fonts_2_236");
	end

	local monsterVo = DataCenter.jokerDuelData.monsterInfo[index];
	if monsterVo ~= nil then
		self.enemyIcon = Lua_ItemIcon.new(self.enemyObj);
		self.enemyIcon:setCanClick(false);
		self.enemyIcon:setLocation(142, 240, 0);
		self.enemyIcon:setData(monsterVo);

		self.enemyHpBar:setMaxValue(monsterVo.max_blood);
		self.enemyHpBar:setValue(monsterVo.blood);
		self.enemyAngerBar:setMaxValue(100);
		self.enemyAngerBar:setValue(monsterVo.curEnergy);
		self.label_enemyName.text = monsterVo.name;
	end
end

function Lua_JokerDuelPickWindow:updataSelect()
	local selectStar = DataCenter.jokerDuelData.getCurStarVo;
	if self.starSelect ~= selectStar.index then
		self.starSelect = selectStar.index;

		self.playerIcon:setData(selectStar);
		self.playerHpBar:setMaxValue(selectStar.max_blood);
		self.playerHpBar:setValue(selectStar.blood);
		self.playerAnagerBar:setMaxValue(100);
		self.playerAnagerBar:setValue(selectStar.curEnergy);

		self.label_power.text = LanUtil.formateStr(126301,tostring(selectStar.heroForce));
	end
end

function Lua_JokerDuelPickWindow:onPassCheckChange(val)
	DataCenter.jokerDuelData.skipDuel = val and 1 or 0;
end

function Lua_JokerDuelPickWindow:onDuleBtnClick()
	local selectStarIndex =  DataCenter.jokerDuelData.curStarIndex;
	local isJump = DataCenter.jokerDuelData.skipDuel;
	
	if isJump == 0 then
		DataCenter.jokerDuelData.isFighting = true;
		Lua_ProxyManager.getProxy("Lua_JokerDuelProxy"):sJokerPickStar(Lua_FightDefine.TEMPLATE_ID_JOKERDUEL, DataCenter.jokerDuelData.stage, self.showData, selectStarIndex, 0);
	else
		Lua_ProxyManager.getProxy("Lua_JokerDuelProxy"):sJokerPickStar(Lua_FightDefine.TEMPLATE_ID_JOKERDUEL, DataCenter.jokerDuelData.stage, self.showData, selectStarIndex, 1);
	end


	self:hide();
end

function Lua_JokerDuelPickWindow:dispose()
	if self.starList ~= nil then
		self.starList:dispose();
		self.starList = nil;
	end
	if self.playerIcon ~= nil then
		self.playerIcon:dispose();
		self.playerIcon = nil;
	end
	if self.enemyIcon ~= nil then
		self.enemyIcon:dispose();
		self.enemyIcon = nil;
	end
	self:superCall("dispose");
end
