--神陵秘境 体能饮料使用窗口
checkRequire("Lua_JokerDuelStarItem");
Lua_JokerDuelRecoverWindow = class("Lua_JokerDuelRecoverWindow", Lua_Window);

function Lua_JokerDuelRecoverWindow:ctor()
	self:superCall("ctor");

	self.showClose = false;
	self.windowName = "Lua_JokerDuelRecoverWindow";
	self.skinName = "JokerDuelRecoverWindow_skin";
end

function Lua_JokerDuelRecoverWindow:buildPanel(go)
	self:superCall("buildPanel", go);
	
	self:addLuaEvent("UPDATE_JOKER_INFO", self, self.updateInfo);--更新界面信息
	self:addLuaEvent("JOKER_USE_DRINK", self, self.recoverSuccess);--使用道具
	self:addLuaEvent("CLOSE_JOKER_WINDOW", self, self.hide);--重置时关闭窗口
end

function Lua_JokerDuelRecoverWindow:buildShowItem()
	self:superCall("buildShowItem");
	
	self.starList = Lua_DragList.new(self.content, 530, 125, Lua_AxisDefine.Vertical);
	self.starList:setListCell(Lua_JokerDuelStarItem, 106, 106, 5);
	self.starList.canDrag = false;
	self.starList:setLocation(4, -60, 0);

	self.cancelBtn:addClickFuntion(self, self.onCancelBtnClick);
	self.sureBtn:addClickFuntion(self, self.onSureBtnClick);
	self.buyBtn:addClickFuntion(self, self.onBuyBtnClick);
end

function Lua_JokerDuelRecoverWindow:showWin(param)
	self.index = param;
	self:updateInfo();
end

function Lua_JokerDuelRecoverWindow:updateInfo()
	local data = DataCenter.jokerDuelData.itemInfo[self.index];
	self.itemSp:setAltas(data.itemVo.iconAtlas, data.itemVo.iconSprite);
	self.label_name.text = data.itemVo.name;
	self.label_desc.text = data.itemVo.des;
	self.label_limit.text = LanUtil.formateStr(201820, tostring(data.limitTime));
	self.label_count.text = LanUtil.formateStr(201821, tostring(data.count));

	self.starList:setArrayData(DataCenter.jokerDuelData.campArr, false);	
end

function Lua_JokerDuelRecoverWindow:recoverSuccess()
	self:updateInfo();

	local itemName = DataCenter.jokerDuelData.itemInfo[self.index].itemVo.colorName;
	OperateAlert.show(LanUtil.formateStr(201816, tostring(itemName)));
end

function Lua_JokerDuelRecoverWindow:onCancelBtnClick()
	self:hide();
end

function Lua_JokerDuelRecoverWindow:onSureBtnClick()
	local curStarVo = DataCenter.jokerDuelData.getCurStarVo;
	if curStarVo == nil then
		OperateAlert.showLangValue(201843);
		return;
	end
	if curStarVo.blood == curStarVo.max_blood then
		OperateAlert.showLangValue(201817);
		return;
	end

	local data = DataCenter.jokerDuelData.itemInfo[self.index];
	if data.limitTime <= 0 then
		OperateAlert.showLangValue(201818);
	elseif data.count >= 1 then
		Lua_ProxyManager.getProxy("Lua_JokerDuelProxy"):sJokerUseDrinks(DataCenter.jokerDuelData.curStarIndex);
	else
		OperateAlert.showLangValue(201804);
	end 
end

function Lua_JokerDuelRecoverWindow:onBuyBtnClick()
	local data = DataCenter.jokerDuelData.itemInfo[self.index];
	local costVo = DataCenter.jokerDuelUtil:getConstVo("buy_drinks_diamond_cost").json_value;

	if data.buyTime > 0 then
		local buyData = {};
		buyData.itemVo = data.itemVo;
		buyData.moneyType = costVo[1];
		buyData.moneyCount = costVo[2];
		buyData.leftTimes = data.buyTime;
		buyData.buyType = 1;
		Lua_WindowUtil.openWin("Lua_JokerBuyGoodsWindow", Lua_WinParam.ACTION_OPEN, buyData);
	else
		OperateAlert.showLangValue(201841);
	end
end

function Lua_JokerDuelRecoverWindow:dispose()
	if self.starList ~= nil then
		self.starList:dispose();
		self.starList = nil;
	end
	self:superCall("dispose");
end