--神陵秘境 目标奖励窗口
Lua_JokerDuelRewardWindow = class("Lua_JokerDuelRewardWindow", Lua_Window);

function Lua_JokerDuelRewardWindow:ctor()
	self:superCall("ctor");

	self.w = 672;
	self.h = 875;
	self.showClose = true;
	self.showTitle = true;
	self.titleSprite = "fonts_2_069";
	self.windowName = "Lua_JokerDuelRewardWindow";
	self.skinName = "JokerDuelRewardWindow_skin";
end

function Lua_JokerDuelRewardWindow:buildPanel(go)
	self:superCall("buildPanel", go);
	
	self:addLuaEvent("UPDATE_JOKER_TASKINFO", self, self.updateRewardInfo);
	self:addLuaEvent("CLOSE_JOKER_WINDOW", self, self.hide);--重置时关闭窗口
end

function Lua_JokerDuelRewardWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.titleName:setLocation(0, 435, 0);
	self.btnClose:setLocation(301, 435, 0);

	self.rewardList = Lua_DragList.new(self.content, 600, 745, Lua_AxisDefine.Vertical);
	self.rewardList:setListCell(Lua_JokerDuelRewardItem, 600, 160, 1);
	self.rewardList:setLocation(0 , 20, 0);

	self:updateRewardInfo();
end

function Lua_JokerDuelRewardWindow:updateRewardInfo()
	local data = DataCenter.jokerDuelData.taskArr;
	if data ~= nil then
		self.rewardList:setArrayData(data);
	end
end

function Lua_JokerDuelRewardWindow:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self:superCall("dispose");
end






























Lua_JokerDuelRewardItem = class("Lua_JokerDuelRewardItem", Lua_ListCell);

function Lua_JokerDuelRewardItem:ctor(p)
	self:superCall("ctor", p, "JokerDuelRewardItem_skin");
end

function Lua_JokerDuelRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardItem = Lua_ItemIconList.new(self.content);
	self.rewardItem.pivot = 1;
	self.rewardItem.canClick = false;
	self.rewardItem.scaleVal = 0.9;
	self.rewardItem:setLayout(120, 120, 999);
	self.rewardItem:setLocation(-240, -15, 0);

	self.duelBtn:addClickFuntion(self, self.onDuelBtnClick);
end

function Lua_JokerDuelRewardItem:setData(data)
	self.data = data;
	self.index = tonumber(data.index);-- 索引
	self.state = tonumber(data.state);-- 状态
	local num = tonumber(data.value);-- 数量
	if self.state == 0 then
		self.duelBtn:setStyle(5);
		self.duelBtn.txt.colorStr = Lua_ColorDefine.transColorStr("ffffff");
		self.duelBtn:setLangValue(201855);
	elseif self.state == 1 then
		self.duelBtn:setStyle(4);
		self.duelBtn.txt.colorStr = Lua_ColorDefine.transColorStr("a84a27");
		self.duelBtn:setLangValue(201856);
	end
	self.duelBtn:setEnable(self.state ~= 2);
	self.receiveSign:setEnable(self.state == 2);

	local defeatNum = DataCenter.jokerDuelData.defeatNum;
	if defeatNum >= num then
		defeatNum = num;
	end
	self.label_title.text = LanUtil.formateStr(201815, tostring(num), tostring(defeatNum), tostring(num));

	self.rewardItem:setArrayData(data.reward);
end

function Lua_JokerDuelRewardItem:onDuelBtnClick()
	if self.state == 0 then
		Lua_WindowUtil.openWin("Lua_JokerDuelRewardWindow", Lua_WinParam.ACTION_CLOSE, nil);
	elseif self.state == 1 then
		Lua_ProxyManager.getProxy("Lua_JokerDuelProxy"):sJokerGetRward(self.index);
	end
end

function Lua_JokerDuelRewardItem:onPressClick()
	self.rewardItem:onBoundClick();
end

function Lua_JokerDuelRewardItem:dispose()
	if self.rewardItem ~= nil then
		self.rewardItem:dispose();
		self.rewardItem = nil;
	end
	self:superCall("dispose");
end