--神陵秘境 主窗口
checkRequire("Lua_JokerDuelStarItem");
checkRequire("Lua_JokerDuelCellItem");
checkRequire("Lua_JokerControlItem");
Lua_JokerDuelWindow = class("Lua_JokerDuelWindow", Lua_Window);

function Lua_JokerDuelWindow:ctor()
	self:superCall("ctor");

	self:addPreLoadRes("/images/jokerDuel/Trumpgame_bg_04.jpg", Lua_LoadFileType.IMG);
	self:addPreLoadRes("/effects/uiEffects/gui_wangpaiduijuemiwu", Lua_LoadFileType.UNITY3D);

	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER
    self.isFullSizeWin = true;
	self.showTitle = true;
    self.showBackBtn = true;
	self.titleAtlas = "jokerDuel_altas";
	self.titleSprite = "fonts_1_112";
	self.windowName = "Lua_JokerDuelWindow";
	self.skinName = "JokerDuelWindow_skin";
end

function Lua_JokerDuelWindow:buildPanel(go)
	self:superCall("buildPanel", go);

	self:addLuaEvent("UPDATE_JOKER_INFO", self, self.updateData);--更新界面信息
	self:addLuaEvent("UPDATE_JOKER_TASKINFO", self, self.updateTaskShow);--更新任务显示
	self:addLuaEvent("UPDATE_JOKER_ITEMINFO", self, self.updateControlShow);--更新道具栏显示
	self:addLuaEvent("UPDATE_JOKER_PASSREWARD", self, self.updateAccruedIncome);--更新过关收益
	self:addLuaEvent("JOKER_USE_DRINK", self, self.onUseDrink);--使用体能药水
	self:addLuaEvent("JOKER_START_SWEEP", self, self.startSweep);--开始扫荡
	self:addLuaEvent("CLOSE_JOKER_WINDOW", self, self.hide);--重置时关闭窗口
end

function Lua_JokerDuelWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.goalTxtBg.alpha = 0.75;
	self.tooltipObj:SetActive(false);--先隐藏道具栏
	-- DataCenter.redDotUtil:updateRedDotVoById(10075, false);--更新红点

	if DataCenter.jokerDuelData.isInScript == 1 then--暂时先屏蔽
		self:showFogEff();--显示迷雾过场
		Lua_ProxyManager.getProxy("Lua_JokerDuelProxy"):sJokerDuelInfo();--请求主界面信息
	else
		Lua_WindowUtil.openWin("Lua_JokerStarSelectWindow", Lua_WinParam.ACTION_OPEN, nil);
	end

	local cellNum = 25;
	local cellWidth = 146;
	local cellHeight = 118;
	local starPos = {-288, 357};
	self.cellArr = Array();
	for i = 1, cellNum do
		local px = (i - 1) % 5;
		local py = Mathf.Ceil(i / 5) - 1;
		local cell = Lua_JokerDuelCellItem.new(self.cellObj, self.tweenObj, i);
		cell.content.name = "JokerDuelCellItem" .. i;
		cell:setLocation(starPos[1] + cellWidth * px, starPos[2] - cellHeight * py, 0);
		self.cellArr:add(cell);	
	end

	self.controlInfo = Array();
	self.controlInfo:add({type = 1, toolNameSp = "Trumpgame_fonts_05", posX = -125.4, openWin = "Lua_JokerDuelRecoverWindow"});
	self.controlInfo:add({type = 2, toolNameSp = "Trumpgame_fonts_08", posX = 5, openWin = "Lua_JokerDuelPassWindow"});
	self.controlInfo:add({type = 3, toolNameSp = "Trumpgame_fonts_06", posX = 134.4, openWin = "Lua_JokerSponsorGoodsWindow"});

	self.controlList = {};
	for i = 1, self.controlInfo:getSize() do
		local item = Lua_JokerControlItem.new(self.tooltipObj, self.controlInfo[i]);
		item:setLocation(self.controlInfo[i].posX, -242, 0);
		self.controlList[self.controlInfo[i].type] = item;
	end

	self.starList = Lua_DragList.new(self.content, 600, 145, Lua_AxisDefine.Vertical);
	self.starList:setListCell(Lua_JokerDuelStarItem, 120, 145, 5);
	self.starList.canDrag = false;
	self.starList:setLocation(0 , -380, 0);


	self.sweepCutTime = DataCenter.jokerDuelUtil:getConstVo("sweep_cut_time").json_value;--扫荡切换时间

	self.tipsBtn:addClickFuntion(self, self.onTipsBtnClick);
	self.attributeBtn:addClickFuntion(self, self.onAttributeBtnClick);
	self.rankBtn:addClickFuntion(self, self.onRankBtnClick);
	self.rewardBox:addClickFuntion(self, self.onRewardBoxClick);
	self.jokerShopIcon:addClickFuntion(self, self.onJokerShopClick);

	self.sweepBtn:addClickFuntion(self, self.onSweepBtnClick);
	self.passSign:addClickFuntion(self, self.onPassSignClick);
	self.passSign.clickScale = false;

	self:startTween();
end

function Lua_JokerDuelWindow:dispose()
	if self.cellArr ~= nil then
		self.cellArr:dispose();
		self.cellArr:clear();
		self.cellArr = nil;
	end
	if self.controlInfo ~= nil then
		self.controlInfo:dispose();
		self.controlInfo:clear();
		self.controlInfo = nil;
	end
	if self.controlList ~= nil then
		for k, v in pairs(self.controlList) do
			v:dispose();
			v = nil;
		end
		self.controlList = nil;
	end
	if self.starList ~= nil then
		self.starList:dispose();
		self.starList = nil;
	end
	if self.fogEff ~= nil then
		self.fogEff:dispose();
		self.fogEff = nil;
	end
	if self._boxEff ~= nil then
		self._boxEff:dispose();
		self._boxEff = nil;
	end

	Lua_CommonUtil.removeTimer(self, self.startSweep);
	Lua_CommonUtil.removeTimer(self, self.onCountDown);
	Lua_CommonUtil.removeTimer(self, self.onTween);

	DataCenter.jokerDuelData.isPlayBossAni = false;
	DataCenter.jokerDuelData.duelLeader = false;
	DataCenter.jokerDuelData:clearSweepData();
	self:superCall("dispose");
end

function Lua_JokerDuelWindow:updateData()
	local data = DataCenter.jokerDuelData; 

	if not data.isFighting then
		for i = 1, data.gridArr:getSize() do
			local index = data.gridArr[i].index;
			self.cellArr[index]:setData(data.gridArr[i]);
		end
	else--挑战不跳过特殊处理
		data.isFighting = false;
		for i = 1, self.cellArr:getSize() do
			local vo = data.gridInfo[i];
			self.cellArr[i]:setData(vo);
		end
	end

	self.shopTipTxt.text = data.aceShopNum;
	self.shopTipObj:SetActive(data.aceShopNum > 0);

	self:updateTaskShow();
	self:updateCampInfo();
	self:updateLevelShow(data);
end

function Lua_JokerDuelWindow:updateTaskShow()--更新任务显示
	local data = DataCenter.jokerDuelData; 
	local rewardState = data.getCurTaskVo.state;
	if rewardState ~= 2 then
		self.goalTxt.text = LanUtil.formateStr(129005, tostring(data.defeatNum), tostring(data.getCurTaskVo.value));
	else
		self.goalTxt:setLangValue(164003);
	end

	if rewardState == 0 then--不可领
		self.rewardBox.alpha = 1;
		self.getBoxEff:setEnable(false);
	elseif rewardState == 1 then--可领
		self.rewardBox.alpha = 0.01;
		self.getBoxEff:setUrl("/effects/uiEffects/gui_lihetiaodong", "gui_lihetiaodong");
		self.getBoxEff:setEnable(true);
	elseif rewardState == 2 then--已领
		if not self.isReceive then
			self.isReceive = true;
			self.rewardBox.alpha = 0.01;
			self.getBoxEff:setUrl("/effects/uiEffects/gui_lihedakai", "gui_lihedakai");
			self.getBoxEff:setEnable(true);
		end
	end
end

function Lua_JokerDuelWindow:updateCampInfo()--更新阵容显示
	self.starList:setArrayData(DataCenter.jokerDuelData.campArr);
end

function Lua_JokerDuelWindow:updateControlShow()--更新道具栏显示
	for i = 1, self.controlInfo:getSize() do
		local index = self.controlInfo[i].type;
		self.controlList[index]:setData(DataCenter.jokerDuelData.itemInfo[index]);
	end
end

function Lua_JokerDuelWindow:updateLevelShow(data)--更新关卡显示
	if not self.isFirstEnter then
		self.isFirstEnter = true;

		if self.fogEff == nil then
			self:showFogEff();
		end
		self.tooltipObj:SetActive(true);

		if data.getCurStarVo == nil then--明星全部退场
			OperateAlert.showLangValue(201806); 
		end

		self:showLastProp(data.lastPropArr);
	end

	local isPassLevel = data.state == 1;--已过关
	local isMaxLevel = data.stage == DataCenter.jokerDuelUtil:getConstVo("max_level").value;--当前关卡为最大
	if isPassLevel and isMaxLevel then
		if data.duelLeader then
			data.duelLeader = false;
			Lua_WindowUtil.openWin("Lua_JokerVictoryWindow", Lua_WinParam.ACTION_OPEN, nil);
		end
		self.passSign:setAltas("jokerDuel_altas", "Trumpgame_icon_12");
	else
		self.passSign:setAltas("jokerDuel_altas", "Trumpgame_icon_11");
	end
	self.passSign:setEnable(isPassLevel);

	self.label_level.text = LanUtil.formateStr(201835, tostring(data.stage));--关卡数显示
	self.sweepBtn:setGray(data.isSweep == 0);

	self:setCountDown();
end

function Lua_JokerDuelWindow:showLastProp(data)--显示上轮未通关属性
	if data ~= nil and data:getSize() > 0 then
		local tipData = {
			des = LanUtil.formateStr(201801, tostring(data[1].show_name), tostring(data[1].showValue), tostring(data[2].show_name), tostring(data[2].showValue)),
			btnType = 1
		};
		Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
	end
	DataCenter.jokerDuelData:clearLastProp();
end

function Lua_JokerDuelWindow:updateAccruedIncome(arr)--显示上轮收益
	if arr:getSize() > 0 then
		Lua_WindowUtil.openWin("Lua_JokerAccruedIncomeWindow", Lua_WinParam.ACTION_OPEN, arr);
	end
end

function Lua_JokerDuelWindow:onUseDrink()--饮用药水
	self:updateCampInfo();
	self:updateControlShow();
end

function Lua_JokerDuelWindow:showFogEff()--全场迷雾特效
	if self.fogEff == nil then
		-- self.fogEff = UICreate.createUIEffect(self.upObject, "/effects/uiEffects/gui_wangpaiduijuemiwu", "gui_wangpaiduijuemiwu", 0, 0);
		-- self.fogEff:SetRenderQueue(5, 1, UIEffect.NormalSort);
		self.fogEff = UICreate.createModelEffImg(self.content, "/effects/uiEffects/gui_wangpaiduijuemiwu", "gui_wangpaiduijuemiwu", 0, 0, 0, 0);
	else
		self.fogEff:setEnable(false);
		self.fogEff:setEnable(true);
	end
end

function Lua_JokerDuelWindow.Get:getBoxEff()--礼盒特效
	if self._boxEff == nil then
		-- self._boxEff = UICreate.createUIEffect(self.tooltipObj1, "/effects/uiEffects/gui_lihetiaodong", "gui_lihetiaodong", 0, 0);
		-- -- self._boxEff:SetRenderQueue(5, 1, UIEffect.NormalSort);
		-- self._boxEff:generateSingleCamera(true);
		self._boxEff = UICreate.createModelEffImg(self.content, "/effects/uiEffects/gui_lihetiaodong", "gui_lihetiaodong", -257, -193, 0, 0);
	end
	return self._boxEff;
end

--关卡倒计时
function Lua_JokerDuelWindow:setCountDown()
	self.timer = tonumber(DataCenter.jokerDuelData.resetTick - DataCenter.roleData.serverTime);
	if self.timer > 0 then
		if not self.isOnTimer then
			self.isOnTimer = true;
			Lua_CommonUtil.addTimer("onCountDown", 1, self, self.onCountDown);
			self.label_time.text = LanUtil.formateStr(201812, tostring(Lua_TimeTransform.transSeconds6(self.timer, true, true)));
		end
	else
		OperateAlert.showLangValue(201809);
		self:hide();
	end
end

function Lua_JokerDuelWindow:onCountDown()
	self.timer = self.timer - 1;
	if self.timer > 0 then
		self.label_time.text = LanUtil.formateStr(201812, tostring(Lua_TimeTransform.transSeconds6(self.timer, true, true)));
	else
		if self.isOnTimer then
			self.isOnTimer = false;
			Lua_CommonUtil.removeTimer(self, self.onCountDown);

			OperateAlert.showLangValue(201809);
			self:hide();
		end
	end
end

--物品浮动效果
function Lua_JokerDuelWindow:startTween()
	self.startTime = getTime();
	Lua_CommonUtil.addTimer("onTween", 0.01, self, self.onTween, nil, -1);
end

function Lua_JokerDuelWindow:onTween()
	local pt = (getTime() - self.startTime) * 6;
	LuaUtil.setObjPos(self.tweenObj, 0, 5 * Mathf.Sin(pt), 0);
end

---------------------------------- 界面打开按钮 ----------------------------------

function Lua_JokerDuelWindow:onTipsBtnClick()
	if DataCenter.jokerDuelData:getClickLimit(1) then return end;

	local tipData = { des = LanUtil.getValue(201836), posX = -180, posY = 540 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
end

function Lua_JokerDuelWindow:onAttributeBtnClick()
	if DataCenter.jokerDuelData:getClickLimit(1) then return end;

	local winData = {};
	winData.posX = 38;
	winData.posY = 388;
	Lua_WindowUtil.openWin("Lua_JokerAttributeWindow", Lua_WinParam.ACTION_OPEN, winData);
end

function Lua_JokerDuelWindow:onRankBtnClick()
	if DataCenter.jokerDuelData:getClickLimit(1) then return end;

	Lua_WindowUtil.openWin("Lua_JokerRankWindow", Lua_WinParam.ACTION_OPEN, nil);
end

function Lua_JokerDuelWindow:onRewardBoxClick()
	if DataCenter.jokerDuelData:getClickLimit(3) then return end;

	Lua_WindowUtil.openWin("Lua_JokerDuelRewardWindow", Lua_WinParam.ACTION_OPEN, nil);
end

function Lua_JokerDuelWindow:onJokerShopClick()
	if DataCenter.jokerDuelData:getClickLimit(3) then return end;

	Lua_WindowUtil.openWin("Lua_JokerDeulShopWindow", Lua_WinParam.ACTION_OPEN, nil);
end

---------------------------------- 功能按钮 ----------------------------------

function Lua_JokerDuelWindow:onPassSignClick()
	local data = DataCenter.jokerDuelData;
	if data.state == 1 and data.stage == DataCenter.jokerDuelUtil:getConstVo("max_level").value then--已通关
		OperateAlert.showLangValue(201803);
	else
		local tipData = {
			des = LanUtil.getValue(201834), btnType = 1, owner = self, sureFun = self.onPassCallBack
		};
		Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
	end
end

function Lua_JokerDuelWindow:onPassCallBack()
	Lua_ProxyManager.getProxy("Lua_JokerDuelProxy"):sJokerNextLevel();
	self:showFogEff();
end

function Lua_JokerDuelWindow:onSweepBtnClick()
	local data = DataCenter.jokerDuelData;
	if data.isSweep == 1 then--可扫荡
		if data.isSweeping then--正在扫荡中
			OperateAlert.showLangValue(201850);
		elseif data.state == 1 then--已过关
			OperateAlert.showLangValue(201851);
		elseif not data.isFighting then--不在战斗中
			local tipData = {
				des = LanUtil.getValue(201811), btnType = 1, owner = self, sureFun = self.onSweepCallBack
			};
			Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
		end
	else
		OperateAlert.showLangValue(201808);
	end
end

function Lua_JokerDuelWindow:onSweepCallBack()--确认扫荡返回
	local monsterNum = DataCenter.jokerDuelData.getMonsterArr:getSize();
	if not DataCenter.jokerDuelData.getBossState then
		monsterNum = monsterNum + 1;
	end
	self.sweepIndex = 0;
	DataCenter.jokerDuelData.isSweeping = true;
	DataCenter.jokerDuelData.sweepTime = monsterNum;
	Lua_ProxyManager.getProxy("Lua_JokerDuelProxy"):sJokerOneKeySweep();
end

function Lua_JokerDuelWindow:startSweep()--扫荡处理
	Lua_CommonUtil.removeTimer(self, self.startSweep);

	local data = DataCenter.jokerDuelData;
	self.sweepIndex = self.sweepIndex + 1;
	data:updateJokerInfo(data.sweepArr[self.sweepIndex]);

	if self.sweepIndex < data.sweepTime - 1 then--刷新普通区域
		Lua_CommonUtil.delayCall(self.sweepCutTime[1], self, self.startSweep);
	elseif self.sweepIndex == data.sweepTime - 1 then--刷新boss区域
		Lua_CommonUtil.delayCall(self.sweepCutTime[2], self, self.startSweep);
	elseif self.sweepIndex == data.sweepTime then--打败boss
		data:clearSweepData();
	end
end