--神陵秘境 排行榜窗口
checkRequire("Lua_JokerRankModelItem");
Lua_JokerRankWindow = class("Lua_JokerRankWindow", Lua_Window);

function Lua_JokerRankWindow:ctor()
	self:superCall("ctor");

	self.w = 672;
	self.h = 972;
	self.showClose = true;
	self.showTitle = true;
	self.titleSprite = "fonts_2_238";
	self.windowName = "Lua_JokerRankWindow";
	self.skinName = "JokerRankWindow_skin";
end

function Lua_JokerRankWindow:buildPanel(go)
	self:superCall("buildPanel", go);
	
	self:addLuaEvent("UPDATE_JOKER_RANKINFO", self, self.updateInfo);--更新界面信息
	self:addLuaEvent("CLOSE_JOKER_WINDOW", self, self.hide);--重置时关闭窗口
end

function Lua_JokerRankWindow:buildShowItem()
	self:superCall("buildShowItem");

	Lua_ProxyManager.getProxy("Lua_JokerDuelProxy"):sJokerRnakInfo();

	self.dragList = Lua_DragList.new(self.content, 600, 460, Lua_AxisDefine.Vertical);
	self.dragList:setListCell(Lua_JokerRankItem, 598, 100, 1);
	self.dragList:setLocation(0, -150, 0);
end

function Lua_JokerRankWindow:updateInfo()
	local data = DataCenter.jokerDuelData;

	if data.ownRankVo.rank ~= 0 then
		self.myRank.text = LanUtil.formateStr(172008, tostring(data.ownRankVo.rank));
	else
		self.myRank:setLangValue(172007);
	end
	self.myName.text = data.ownRankVo.player_show.name;
	self.myLevel.text = LanUtil.formateStr(201810, tostring(data.ownRankVo.value));

	self:updateModel(data.rankArr);
	self.dragList:setArrayData(data.rankArr);
end

function Lua_JokerRankWindow:updateModel(arr)
	if self.modelList == nil then
		self.modelList = {};
	end

	for i = 1, 3 do
		if arr[i].playerInfo ~= nil then
			if self.modelList[i] == nil then
				self.modelList[i] = Lua_JokerRankModelItem.new(self.content, i);
			end

			local modelData = DataCenter.roleData:parseProtoShowRoleStructToUsData(arr[i].playerInfo);
			self.modelList[i]:setData(modelData);
			self.modelList[i]:setShow(true);
		else
			if self.modelList[i] ~= nil then
				self.modelList[i]:setShow(false);
			end
		end
	end
end

function Lua_JokerRankWindow:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	if self.modelList ~= nil then
		for i = 1, #self.modelList do
			if self.modelList[i] ~= nil then
				self.modelList[i]:dispose();
				self.modelList[i] = nil;
			end
		end
		self.modelList = nil;
	end
	self:superCall("dispose");
end























checkRequire("Lua_AvatarItem");
Lua_JokerRankItem = class("Lua_JokerRankItem", Lua_ListCell);
function Lua_JokerRankItem:ctor(p)
	self:superCall("ctor", p ,"JokerRankItem_skin");
end

function Lua_JokerRankItem:buildShowItem()
	self:superCall("buildShowItem");

	self.avatarItem = Lua_AvatarItem.new(self.playerObj);
	self.avatarItem:setAvatarClick(self, self.onavatarItemChick);
	self.avatarItem.avatarIcon.clickScale = false;
	self.avatarItem:setScale(0.8, 0.8, 0);
	self.avatarItem:setLocation(-116, 0, 0);

	-- self.levelItem = Lua_ShowLevelItem.new(self.playerObj);
	-- self.levelItem:setLocation(-65, 1.6, 0);
	-- self.levelItem:setIconScale(0.8);
end

function Lua_JokerRankItem:setData(data)
	self.data = data;

	if data.rank <= 3 then
		self.rankImg:setAltas("iconantlas1", "common_icon_001" .. (data.rank - 1));
		self.rankImg:resetSize();
		self.rankImg:setEnable(true);
		self.rank:setEnable(false);
	else
		self.rankImg:setEnable(false);
		self.rank.text = tostring(data.rank);
		self.rank:setEnable(true);
	end

	local playerInfo = data.playerInfo;
	local isHasPlayer = playerInfo ~= nil;
	if isHasPlayer then
		local vipParam = playerInfo.vip ~= 0 and playerInfo.vip or nil;
		self.avatarItem:setRoleVip(vipParam);
		self.avatarItem:setRoleAvatar(playerInfo.head_icon);

		-- local lvData = {};
		-- lvData.pivot = 1;
		-- lvData.level = playerInfo.level;
		-- lvData.left_dec = "[4A6793]"..data.getShowLevel.."[-]";
		-- lvData.font = 20;
		-- self.levelItem:setData(lvData);

		self.name.text = playerInfo.name;

		local leagueStr = tonumber(playerInfo.league_id) ~= 0 and tostring(playerInfo.league_name) or LanUtil.getValue(172017);
		self.league.text = LanUtil.formateStr(172018, leagueStr);

		self.integral:setLocation(155, 0, 0);
		self.integral.text = LanUtil.formateStr(201810, tostring(data.passNum));
	else
		self.integral:setLocation(95, 0, 0);
		self.integral:setLangValue(201020);
	end
	self.playerObj:SetActive(isHasPlayer);
	self.noPlayerTxt:setEnable(not isHasPlayer);
end

function Lua_JokerRankItem:onavatarItemChick()
	if DataCenter.roleData.roleId == tonumber(self.data.playerInfo.id) then
		OperateAlert.showLangValue(172006);
	else
		Lua_WindowUtil.openWin("Lua_PlayerInfoWindow", Lua_WinParam.ACTION_OPEN, tonumber(self.data.playerInfo.id));
	end
end

function Lua_JokerRankItem:dispose()
	if self.avatarItem ~= nil then
		self.avatarItem:dispose();
		self.avatarItem = nil;
	end
	if self.levelItem ~= nil then
		self.levelItem:dispose()
		self.levelItem = nil
	end
	self:superCall("dispose");
end

