--神陵秘境 英雄选择窗口
Lua_JokerStarSelectWindow = class("Lua_JokerStarSelectWindow", Lua_Window);
function Lua_JokerStarSelectWindow:ctor()
	self:superCall("ctor");

	self.blackAlpha = 0.3;
	self.isClickClose = false;
	self.showClose = true;
	self.windowName = "Lua_JokerStarSelectWindow";
	self.skinName = "JokerStarSelectWindow_skin";

	self.isNeedClose = true;--是否关闭王牌界面
end

function Lua_JokerStarSelectWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.btnClose:setLocation(300, 415, 0);

	self.recordSelectDic = {};
	self.recordSelectIdDic = {};
	self.showSelectHeroDic = {};
	self.lineup_hero_num = DataCenter.jokerDuelUtil:getConstVo("lineup_hero_num").value;--英雄上阵数量

	--英雄展示
	self.showheroInfo = Array();
	local pos = {-230, -120, -10, 100, 210};
	local perWidth = 75;
	for i = 1, self.lineup_hero_num do
		local item = Lua_JokerShowHeroItem.new(self.content);
		item:setLocation(pos[i], 250, 0);
		self.showheroInfo:add(item);
		self.showSelectHeroDic[i] = 0;
	end
	
	self.campSiftPanel = Lua_CampSiftPanel.new(self.content);
    self.campSiftPanel:setLocation(-32, -260, 0);
    self.campSiftPanel:setSiftItem(75);
    self.campSiftPanel:setArrayData(DataCenter.heroUtil.siftAllInfo);
    self.campSiftPanel:setCallBack(self, self.onCampSelected);
    self.campSiftPanel:setSelected(Lua_HeroUtil.All_TYPE, true);
 
	self.dragList = Lua_DragList.new(self.content, 600, 250, Lua_AxisDefine.Vertical);
	self.dragList:setListCell(Lua_JokerStarSelectItem, 120, 130, 5);
	self.dragList:setLocation(0, 28, 0);
	self.dragList.canLongPress = true;

	self.one_btn:addClickFuntion(self, self.onOneBtnClick);
	self.duel_btn:addClickFuntion(self, self.onDuelBtnClick);

	self:addLuaEvent("ON_SHOW_HERO_ITEM", self, self.onShowHeroInfo); -- 点击展示英雄返回
	self:addLuaEvent("JOKER_SELECT_HERO_ITEM", self, self.updataSelectHeroInfo); -- 选择单个英雄返回
end

--页签
function Lua_JokerStarSelectWindow:onCampSelected(val)
	if self.starTypeSelect == val then
		return;
	end
	self.starTypeSelect = val;

	self:updateheroSiftInfo();
end

function Lua_JokerStarSelectWindow:updateheroSiftInfo()
	local starTypeInfo = DataCenter.jokerDuelData:showSelectHeroInfo(self.starTypeSelect);
	self.dragList:setArrayData(starTypeInfo, false);
end

-- 选择英雄
function Lua_JokerStarSelectWindow:updataSelectHeroInfo(data)
	
	if self.recordSelectIdDic[data.id] ~= nil and self.recordSelectDic[data.unique_id] == nil then
		OperateAlert.showLangValue(201854);
        return;
	end

    if self.selectNum >= self.lineup_hero_num and self.recordSelectDic[data.unique_id] == nil then
        OperateAlert.showLangValue(201852);
        return;
    end

    if data.isSelect == false then
        data.isSelect = true;
        self.recordSelectDic[data.unique_id] = 1;
        self.recordSelectIdDic[data.id] = 1;
        self:selectIndex(data.unique_id);
    else
        data.isSelect = false;
        self.recordSelectDic[data.unique_id] = nil;
        self.recordSelectIdDic[data.id] = nil;
        self:cancelIndex(data.unique_id);
    end
    
    self:updateSelect();
    self:updateShowHeroInfo();
end

--点击展示英雄
function Lua_JokerStarSelectWindow:onShowHeroInfo(data)
    local unique_id = data.unique_id;
    self.recordSelectDic[unique_id] = nil;
    self.recordSelectIdDic[data.id] = nil;
    self:cancelIndex(unique_id);
    self:updateShowHeroInfo();
    self:updateSelect(unique_id);
end

--展示英雄
function Lua_JokerStarSelectWindow:updateShowHeroInfo()
    for i = 1, self.showheroInfo:getSize() do
		self.showheroInfo[i]:setData(self.showSelectHeroDic[i]);
	end
end

function Lua_JokerStarSelectWindow:updateSelect(unique_id)
    if self.dragList ~= nil then
        local arr = self.dragList.showList;
        local len = arr:getSize();
        for i = 1, len do
        	if unique_id ~= nil then
        		if arr[i].data.unique_id == unique_id then
        			arr[i].data.isSelect = false;
        		end
        	end
            arr[i]:updateSelect();
        end
    end
end

--一键选择
function Lua_JokerStarSelectWindow:onOneBtnClick()
	if self.selectNum >= self.lineup_hero_num then
        OperateAlert.showLangValue(201852);
        return;
    end
    local need_num = self.lineup_hero_num - self.selectNum;
    if self.dragList ~= nil then
        local arr = self.dragList.showList;
        local len = arr:getSize();
        local unique_id;
        for i = 1, len do
    		if arr[i].data.isSelect == false and self.recordSelectIdDic[arr[i].data.id] == nil then
    			need_num = need_num - 1;
    			arr[i].data.isSelect = true;
    			self.recordSelectDic[arr[i].data.unique_id] = 1;
    			self.recordSelectIdDic[arr[i].data.id] = 1;
		        self:selectIndex(arr[i].data.unique_id);
    		end
            arr[i]:updateSelect();
            if need_num == 0 then
            	break;
            end
        end
    end
    self:updateShowHeroInfo();
end

--进入皇陵
function Lua_JokerStarSelectWindow:onDuelBtnClick()
	if self.selectNum == 0 then
		OperateAlert.showLangValue(201853);
		return
	end
	if self.selectNum < self.lineup_hero_num then
		local tipData = {
			des = LanUtil.getValue(201800), btnType = 1, owner = self, sureFun = self.onSureCallBack
		};
		Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
	else
		self:onSureCallBack();
	end
end

function Lua_JokerStarSelectWindow:onSureCallBack()
	self.isNeedClose = false;
	Lua_ProxyManager.getProxy("Lua_JokerDuelProxy"):sSelectTeam(self.showSelectHeroDic);
	self:hide();
end

--选择的数量
function Lua_JokerStarSelectWindow.Get:selectNum()
    local selectNum = 0;
    for i=1,#self.showSelectHeroDic do
    	if self.showSelectHeroDic[i] ~= 0 then
    		selectNum = selectNum+1;
    	end
    end
    return selectNum;
end

--选择的索引
function Lua_JokerStarSelectWindow:selectIndex(uid)
    for i=1,#self.showSelectHeroDic do
    	if self.showSelectHeroDic[i] == 0 then
    		self.showSelectHeroDic[i] = uid;
    		break;
    	end
    end
end

--取消的索引
function Lua_JokerStarSelectWindow:cancelIndex(uid)
    for i=1,#self.showSelectHeroDic do
    	if self.showSelectHeroDic[i] == uid then
    		self.showSelectHeroDic[i] = 0;
    		break;
    	end
    end
end



function Lua_JokerStarSelectWindow:dispose()
	if self.showPanel ~= nil then
		self.showPanel:dispose();
		self.showPanel = nil;
	end

	if self.showheroInfo ~= nil then
		self.showheroInfo:dispose();
		self.showheroInfo:clear();
		self.showheroInfo = nil;
	end

	if self.campSiftPanel ~= nil then
		self.campSiftPanel:dispose();
		self.campSiftPanel = nil;
	end

	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end

	self.recordSelectDic = nil;
	self.showSelectHeroDic = nil;
	self.recordSelectIdDic = nil;
	
	if self.isNeedClose then
		if Lua_WindowUtil.isWindowShowing("Lua_JokerDuelWindow") == true then
			Lua_WindowUtil.openWin("Lua_JokerDuelWindow", Lua_WinParam.ACTION_CLOSE, nil);
		end
	end
	self:superCall("dispose");
end




























--英雄展示列表
Lua_JokerShowHeroItem = class("Lua_JokerShowHeroItem", Lua_DisplayObject);
function Lua_JokerShowHeroItem:ctor(p)
	self:superCall("ctor", p, nil);
end

function Lua_JokerShowHeroItem:buildShowItem()
	self:superCall("buildShowItem");
	self.toolImg = Lua_ItemIcon.new(self.content);
	self.toolImg:setScale(0.9, 0.9);
    self.toolImg:setCanClick(false);

	self.toolImg.iconBg:addClickFuntion(self, self.onBtnClick);
end

function Lua_JokerShowHeroItem:setData(unique_id)
	if unique_id ~= 0 then
		self.data = DataCenter.heroData:getItemByUniqueId(unique_id);
		self.toolImg:setData(self.data);
	else
		self.data = nil;
		self.toolImg:setData(nil);
	end
end

function Lua_JokerShowHeroItem:onBtnClick()
	if self.data ~= nil then
		Lua_MsgUtil.callFunc("ON_SHOW_HERO_ITEM",self.data);
	end
end

function Lua_JokerShowHeroItem:dispose()
	if self.toolImg ~= nil then
		self.toolImg:dispose();
		self.toolImg = nil;
	end
	self:superCall("dispose");
end



















Lua_JokerStarSelectItem = class("Lua_JokerStarSelectItem", Lua_ListCell);
function Lua_JokerStarSelectItem:ctor(p)
	self:superCall("ctor", p, nil);
end

function Lua_JokerStarSelectItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon = Lua_ItemIcon.new(self.content);
    self.itemIcon:setCanClick(false);

	self.select_bg = UICreate.createUIAtlasImage(self.content, "iconantlas1", "common_progress_002_b", 0, 0, 106, 106);
    self.select_bg:setEnable(false);

	self.select_spr = UICreate.createUIAtlasImage(self.content, "iconantlas1", "common_widget_015", 0, 5, 66, 64);
	self.select_spr:setEnable(false);
end

function Lua_JokerStarSelectItem:setData(data)
	self.data = data;
	self.hvo = DataCenter.heroData:getItemByUniqueId(data.unique_id);
	self.itemIcon:setData(self.hvo);

	self:updateSelect();
end

function Lua_JokerStarSelectItem:updateSelect()
	self.select_bg:setEnable(self.data.isSelect);
	self.select_spr:setEnable(self.data.isSelect);
end

function Lua_JokerStarSelectItem:onPressClick(go)
	if self.hvo.isSpecialState == true then
        OperateAlert.showLangValue(126206);
		return;
	end
    Lua_MsgUtil.callFunc("JOKER_SELECT_HERO_ITEM",self.data);
end

function Lua_JokerStarSelectItem:onLongPressClick(go)
	print("长按")
	-- Lua_WindowUtil.openWin("Lua_CelebrityAttributeTipsWindow", Lua_WinParam.ACTION_OPEN, self.data);
end

function Lua_JokerStarSelectItem:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	self.select_bg = nil;
	self.select_spr = nil;
	self:superCall("dispose");
end