--神陵秘境 格子Item
Lua_JokerDuelCellItem = class("Lua_JokerDuelCellItem", Lua_DisplayObject);

function Lua_JokerDuelCellItem:ctor(p, tweenParent, index)
	self.index = index;
	self.tweenParent = tweenParent;
	self:superCall("ctor", p, "JokerDuelCellItem_skin");
end

--格子类型：0：空白格子 1：猜拳互动 2：主持问答 3：保险柜 4：粉丝事件 5：赞助商店 6：钥匙 7：粉丝祝福 8：道具 9：迷雾 10：怪物 11：转椅
--随机事件类型：1：猜拳互动 2：主持问答 3：保险柜 4：粉丝事件 5：赞助商店
function Lua_JokerDuelCellItem:buildShowItem()
	self:superCall("buildShowItem");

	self.cellBg.alpha = 0.01;
	self.tweenObj.name = "tweenObj" .. self.index;

	self.refershTime = DataCenter.jokerDuelUtil:getConstVo("refersh_area_time").json_value;--区域刷新时间
	self.cellBg:addClickFuntion(self, self.onCellClick);
	self:addLuaEvent("CLEAR_JOKER_SPONSORSHOP", self, self.clearSponsorShop);--赞助商店清理
end

function Lua_JokerDuelCellItem:dispose()
	if self._monsterIcon ~= nil then
		self._monsterIcon:dispose();
		self._monsterIcon = nil;
	end
	if self.tweenImage ~= nil then
		TweenUtil.getInstance():stop(self.tweenImage.mainContent);
		self.tweenImage:dispose();
		self.tweenImage = nil;
	end

	if DataCenter.jokerDuelData.isAutoPick == 1 and (self.eventType == 7 or self.eventType == 8) then--退出时拾取处理
		Lua_ProxyManager.getProxy("Lua_JokerDuelProxy"):sJokerClickEvent(self.index);
	end

	self.tweenParent = nil;
	Lua_CommonUtil.removeTimer(self, self.onPlayFade);
	Lua_CommonUtil.removeTimer(self, self.onCollectTimer);
	self:disposeEffect();
	self:superCall("dispose");
end

function Lua_JokerDuelCellItem:setData(data)
	self.data = data;

	if self.eventType ~= self.data.eventType then
		self:updateEffShow();

		self.eventType = self.data.eventType;
		if not self.isPlayEff then
			self:updateCellShow();
		end
	end
end

function Lua_JokerDuelCellItem:updateEffShow()
	if self.eventType == 9 then--迷雾退散处理
		self.showEffect:setUrl("/effects/uiEffects/gui_miwu", "gui_miwu");
		self:setEffectShow(false);

		local index = DataCenter.jokerDuelData.getBossState and 2 or 1;--boss区域刷新处理
		self:addFadeTimer(index, 0.2);
	elseif self.eventType == 11 then--转椅转动处理
		DataCenter.jokerDuelData.isPlayBossAni = true;

		self.showEffect:setUrl("/effects/uiEffects/gui_zhuanyitexiao2", "gui_zhuanyitexiao2");
		self:setEffectShow(false);
		self:addFadeTimer(3, 0.2);
	end
end

function Lua_JokerDuelCellItem:updateCellShow()
	if self.eventType == 0 then--空白格子
		self:setShowTween(false);
		self:setCellShow(false, false, false, false, false);
	elseif self.eventType <= 8 then--1 ~ 5:随机事件 6：钥匙 7：粉丝祝福 8：道具
		if self.eventType == 6 or self.eventType == 8 then
			self.eventIcon:setAltas(tostring(self.data.itemVo.iconAtlas), tostring(self.data.itemVo.iconSprite));
		else
			local showSp = DataCenter.jokerDuelUtil:getEventFlushVo(self.eventType).showIcon;
			self.eventIcon:setAltas("jokerDuel_altas", tostring(showSp));
		end

		if (self.eventType == 7 or self.eventType == 8) and DataCenter.jokerDuelData.isAutoPick == 1 then--开始自动拾取
			self:setCollectTimer();
		end

		self:setShowTween(not (self.data.eventType >= 3 and self.data.eventType <= 5));
		self:setCellShow(true, false, true, false, self.eventType ~= 5);
	elseif self.eventType == 9 then--迷雾
		self:setShowTween(false);
		self:setCellShow(true, true, false, false, false);
	elseif self.eventType == 10 then--怪物
		self.monsterIcon:setData(self.data.monsterVo);
		self.monsterFrame:setEnable(self.data.monsterVo.isLeader == 1);

		if self.data.monsterVo.isLeader == 1 then--通行证界面特殊处理
			DataCenter.jokerDuelData.isPlayBossAni = false;
			Lua_MsgUtil.callFunc("UPDATE_JOKER_MONSTERINFO");
		end

		self:setShowTween(true);
		self:setCellShow(true, false, false, true, true);
	elseif self.eventType == 11 then--转椅
		self.eventIcon:setAltas("jokerDuel_altas", "Trumpgame_icon_07");

		self:setShowTween(false);
		self:setCellShow(true, false, true, false, false);
	end
end

function Lua_JokerDuelCellItem:setCellShow(isClick, isFog, isEvent, isMonster, isBottom)
	self.cellBg:setEnable(isClick);
	self.fogBg:setEnable(isFog);
	self.eventIcon:setEnable(isEvent);
	self.monsterObj:SetActive(isMonster);
	self.bottom:setEnable(isBottom);
end

function Lua_JokerDuelCellItem.Get:monsterIcon()--怪物
	if self._monsterIcon == nil then
		self._monsterIcon = Lua_ItemIcon.new(self.monsterObj);
		self._monsterIcon:setCanClick(false);
		self._monsterIcon:setScale(0.85, 0.85, 0.85);
		self._monsterIcon:setLocation(0, 0, 0);
	end
	return self._monsterIcon;
end

function Lua_JokerDuelCellItem.Get:showEffect()--特效
	if self._showEffect == nil then
		self._showEffect = UICreate.createModelEffImg(self.content, "", "", 0, 0, 0, 0);
	end
	return self._showEffect;
end

function Lua_JokerDuelCellItem:setEffectShow(bShow)--设置特效显示
	if self._showEffect ~= nil then
		self.showEffect:setEnable(bShow);
	end
end

function Lua_JokerDuelCellItem:disposeEffect()--清理特效
	if self._showEffect ~= nil then
		self._showEffect:dispose();
		self._showEffect = nil;
	end
end

function Lua_JokerDuelCellItem:onCellClick()
	if self.isPlayEff or DataCenter.jokerDuelData:getClickLimit(3) then return end;
	Lua_ProxyManager.getProxy("Lua_JokerDuelProxy"):sJokerClickEvent(self.index);
	if self.eventType > 0 and self.eventType <= 5 then--随机事件
		local openWindow = DataCenter.jokerDuelUtil:getEventFlushVo(self.eventType).openWindow;
		Lua_WindowUtil.openWin(openWindow, Lua_WinParam.ACTION_OPEN, self.index);
	elseif self.eventType >= 6 and self.eventType <= 8 then--拾取道具
		self:showCollectTip();
	elseif self.eventType == 9 or self.eventType == 11 then--迷雾,转椅
		OperateAlert.showLangValue(201802);
	elseif self.eventType == 10 then
		if DataCenter.jokerDuelData.getCurStarVo == nil then
			OperateAlert.showLangValue(201807);
			return;
		end
		Lua_WindowUtil.openWin("Lua_JokerDuelPickWindow", Lua_WinParam.ACTION_OPEN, self.index);
	end
end

function Lua_JokerDuelCellItem:showCollectTip()
	self:removeCollectTimer();
	self:setCellShow(false, false, false, false, false);

	if self.data.eventType == 6 or self.data.eventType == 8 then--钥匙、道具
		OperateAlert.show(LanUtil.formateStr(201826, tostring(self.data.itemVo.colorName), tostring(self.data.itemVo.count)));
	elseif self.data.eventType == 7 then--粉丝祝福
		OperateAlert.show(LanUtil.formateStr(201825, tostring(self.data.propVo.show_name), tostring(self.data.propVo.showValue)));
	end
end

function Lua_JokerDuelCellItem:setCollectTimer()
	if not self.isCollect then
		self.isCollect = true;

		self.collectTime = 0;
		self.cutCollectTime = 1;
		self.collectEndTime = DataCenter.jokerDuelUtil:getConstVo("item_fade_time").value;
		Lua_CommonUtil.addTimer("onCollectTimer", self.cutCollectTime, self, self.onCollectTimer);
	end
end

function Lua_JokerDuelCellItem:onCollectTimer()
	self.collectTime = self.collectTime + self.cutCollectTime;
	if self.collectTime >= self.collectEndTime then
		Lua_ProxyManager.getProxy("Lua_JokerDuelProxy"):sJokerClickEvent(self.index);
		self:showCollectTip();
	end
end

function Lua_JokerDuelCellItem:removeCollectTimer()
	self.isCollect = false;
	Lua_CommonUtil.removeTimer(self, self.onCollectTimer);
end

function Lua_JokerDuelCellItem:setShowTween(val)--物品浮动效果
	if val then
		self.tweenObj.transform.parent = self.tweenParent.transform;
	else
		self.tweenObj.transform.parent = self.content.transform;
		LuaUtil.setObjPos(self.tweenObj, 0, 0, 0);
	end
end

function Lua_JokerDuelCellItem:addFadeTimer(index, cutTime)--添加过场特效计时器
	self.onFadeTime = 0;
	self.startFadeTime = self.refershTime[index][1];
	self.endFadeTime = self.refershTime[index][2];
	self.cutFadeTime = cutTime;

	if not self.isPlayEff then
		self.isPlayEff = true;
		Lua_CommonUtil.addTimer("onPlayFade", self.cutFadeTime, self, self.onPlayFade);
	end
end

function Lua_JokerDuelCellItem:onPlayFade()--播放过场特效
	self.onFadeTime = self.onFadeTime + self.cutFadeTime;
	if self.onFadeTime >= self.endFadeTime then
		Lua_CommonUtil.removeTimer(self, self.onPlayFade);
		self.isPlayEff = false;
		self:setEffectShow(false);
		self:updateCellShow();
	elseif self.onFadeTime >= self.startFadeTime then
		self.fogBg:setEnable(false);
		self.eventIcon:setEnable(false);
		self.bottom:setEnable(false);
		self:setEffectShow(true);
	end
end

function Lua_JokerDuelCellItem:clearSponsorShop(index)--赞助商店清理
	if index == self.index then
		if self.tweenImage == nil then
			local showSp = DataCenter.jokerDuelUtil:getEventFlushVo(5).showIcon;
			self.tweenImage = UICreate.createUIAtlasImage(self.parent, "jokerDuel_altas", tostring(showSp), 0, 0, 98, 98);
		end
		self.eventType = 0;
		self:updateCellShow();

		self.tweenImage:setLocation(self.posX, self.posY, 0);
		self.tweenImage:setEnable(true);
		TweenUtil.getInstance():stop(self.tweenImage.mainContent);
		TweenUtil.getInstance():addTween(self.tweenImage.mainContent, 1.5, 0, 
			266, -241, 0, 
			0, 0, 0, 
			0.75, 0.75, 0.75, 
			self, self.onTweenComplete, 0, false);
	end
end

function Lua_JokerDuelCellItem:onTweenComplete()
	TweenUtil.getInstance():stop(self.tweenImage.mainContent);
	if self.tweenImage ~= nil then
		self.tweenImage:setEnable(false);
	end
end