--神陵秘境 排行榜模型Item
checkRequire("Lua_JokerRankModelVo");
Lua_JokerRankModelItem = class("Lua_JokerRankModelItem", Lua_DisplayObject);

function Lua_JokerRankModelItem:ctor(p, rank)
	self.rank = rank;
	self:superCall("ctor", p);
end

function Lua_JokerRankModelItem:buildShowItem()
	self:superCall("buildShowItem");

	self.config = DataCenter.jokerDuelUtil:getRankModelVo(self.rank);

	self.rankImg = UICreate.createUIAtlasImage(self.content, "iconantlas1", "common_icon_001" .. (self.rank - 1), 0, 0, 0, 0);
	self.rankImg:setLocation(self.config.icon_pos[1], self.config.icon_pos[2], 0);
	self.rankImg:setScale(self.config.icon_scale[1], self.config.icon_scale[2], 0);

	self.label = UICreate.createLabel(self.content, "", -50, 0, 24, 24, self.config.label_size);
	self.label.pivot = UIWidget.Pivot.Left;
	self.label.overflowMethod = UILabel.Overflow.ResizeFreely;
	self.label.colorStr = Lua_ColorDefine.transColor("FFE220");
	self.label:setLocation(self.config.label_pos[1], self.config.label_pos[2], 0);
end

function Lua_JokerRankModelItem:setData(data)
	if self.model == nil then
		self.model = ModelPlayer();
		self.model:init(self.content, data, Vector3(0, 0, 0), Vector3(0, 0, 0), self.config.model_scale);
		self.model:SetRenderQueue(5, 1, UIEffect.NormalSort);
	end
	self.model:updatData(data);
	self.model:setDir(-90);
	self.model:setPosition(self.config.model_pos[1], self.config.model_pos[2], 0);

	self.label.text = data.nickname;
end

function Lua_JokerRankModelItem:setShow(val)
	if self.model ~= nil then
		self.model:setActive(val);
	end
	self.rankImg:setEnable(val);
	self.label:setEnable(val);
end

function Lua_JokerRankModelItem:dispose()
	if self.model ~= nil then
		self.model:dispose()
		self.model = nil
	end
	if self.rankImg ~= nil then
		self.rankImg:dispose();
		self.rankImg = nil;
	end
	if self.label ~= nil then
		self.label:dispose();
		self.label = nil;
	end
	self:superCall("dispose");
end