--神陵秘境 赞助商店、商品Item
Lua_JokerSponsorItem = class("Lua_JokerSponsorItem", Lua_DisplayObject);

function Lua_JokerSponsorItem:ctor(p, types)
	self.type = types;
	self:superCall("ctor", p, "JokerSponsorItem_skin");
end

function Lua_JokerSponsorItem:buildShowItem()
	self:superCall("buildShowItem");

	self.shopItem = Lua_ItemIcon.new(self.content);
	self.shopItem:setLocation(0, 97, 0);

	self.buyBtn:addClickFuntion(self, self.onBuyBtnClick);
end

function Lua_JokerSponsorItem:setData(data, cellIndex)
	self.data = data;
	self.cellIndex = cellIndex;

	self.shopItem:setData(data.itemVo);
	self.label_num.text = numberTrans(data.costNum);
	self.costItem:setAltas(data.costVo.iconAtlas, data.costVo.iconSprite);
	self.costItem:resetSize();

	
	local offsetX = 0;
	if data.costVo.id == Lua_ResourcesData.DIAMOND then
		self.costItem:setScale(1, 1, 1);
	else
		self.costItem:setScale(0.5, 0.5, 0.5);

		local gap = 65 - self.label_num.width;
		if gap < 0 then
			offsetX = gap;
		end
	end
	LuaUtil.setObjPos(self.costObj, offsetX, 0, 0);

	self.label_discount.text =  tostring(data.discount);
	self.discountObj:SetActive(data.showDiscount == 1);

	self.buyBtn:setGray(data.amount <= 0);
	self.sellOutObj:SetActive(data.amount <= 0);

	self.buyCost = data.amount * data.costNum;
end

function Lua_JokerSponsorItem:onBuyBtnClick()
	if self.data.amount > 0  then
		local itemVo = self.data.itemVo;
		local costNum = tostring(numberTrans(self.buyCost));
		local itemName = tostring(itemVo.name);
		local itemNum = tostring(numberTrans(itemVo.count));
		local str = spliceIconStr(itemVo.iconAtlas, itemVo.iconSprite, itemVo.iconWidth, itemVo.iconHeight);
		local tipData = {
			des = LanUtil.getValue(201822)..str..LanUtil.formateStr(201823, costNum, itemName, itemNum),
			posY = 34, owner = self, sureFun = self.rSureCostClick
		};
		Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN ,tipData);
	else
		OperateAlert.showLangValue(130010); 
	end
end

function Lua_JokerSponsorItem:rSureCostClick()
	if DataCenter.moneyData:isMoneyEnough(self.data.costVo.id, self.buyCost, true, true, false) then
		if self.type == 1 then
			Lua_ProxyManager.getProxy("Lua_JokerDuelProxy"):sJokerBuyContactGoods(self.data.index, self.data.amount);
			Lua_WindowUtil.openWin("Lua_JokerSponsorGoodsWindow", Lua_WinParam.ACTION_CLOSE, nil);
		else
			Lua_ProxyManager.getProxy("Lua_JokerDuelProxy"):sJokerBuySponsorItem(self.data.index, self.data.amount, self.cellIndex);
		end
	end
end

function Lua_JokerSponsorItem:dispose()
	if self.shopItem ~= nil then
		self.shopItem:dispose();
		self.shopItem = nil;
	end
	self:superCall("dispose");
end